<?php
class Qmlrversionupdate
{
	function __construct()
	{
		
	}
	function update()
	{
		//version 1.8
		$path = preg_replace('/wp-content(?!.*wp-content).*/','',__DIR__);
	    require_once($path.'wp-load.php');
		global $wpdb;
		
		if(!get_option('qmlr_version_update_18'))
		{
			$table=$wpdb->prefix."quick_mail_email_lists";
			$byadminjsn=base64_encode(json_encode(array('byadmin'=>1)));
			
			$byadminjsn .='@admin@';
			
			$qry=$wpdb->get_results("select id,exf from ".$table." where exf not in('1')");
			
			foreach($qry as $data)
			{
				$updateddata=$data->exf;
				
				$updateddata .="@subs@";
				
				$wpdb->query($wpdb->prepare("update ".$table." set exf=%s where id=%d",array($updateddata,$data->id)));
			}
			
			$wpdb->query($wpdb->prepare("update ".$table." set exf=%s where exf='1'",array($byadminjsn)));
			
			add_option('qmlr_version_update_18','1');
		}
		if(!get_option('qmlr_version_update_22'))
		{
			add_option('wqmlr_cross_origins','');
			add_option('qmlr_version_update_22','1');
		}
		else
		{
		    $crosspath=__FILE__;
			$crosspath=str_replace('\\','/',$crosspath);
			$crossfile=str_replace('assets/updates.php','wpquickmailer/origin.txt',$crosspath);
			$fp=fopen($crossfile,'w');
			fwrite($fp,get_option('wqmlr_cross_origins'));
			fclose($fp);
		}
		if(!get_option('qmlr_version_update_23'))
		{
			add_option('qmlr_version_update_23','1');
			$pref="wp_quick_mlr_";
			$newapikey=substr(str_shuffle('zasdfghjklzxcvbnmqwertyuiopQWERTYUIOPASDFGHJKLZXCVBNM@1234567890'),1,20); 
			 $newapikey="mleng:".$newapikey;
			add_option($pref."list_api_key",$newapikey);
		}
		if(!get_option('qmlr_version_update_26'))
		{
			$bouncecredentialsjsn=json_encode(array('host'=>'','port'=>'','encryption'=>'','username'=>'','password'=>'','service'=>'imap','return_path'=>''));

			$smtptable=$wpdb->prefix."quick_mail_smtp_settings";
			$fromtable=$wpdb->prefix."quick_mlr_email_setting";

			$alt1=$wpdb->query("alter table `".$smtptable."` add `imap_credentials` text not null after `encryption`");

			$alt2=$wpdb->query("alter table `".$fromtable."` add `bounce_email` text not null after `replyname`");

			if($alt1 && $alt2)
			{
				$wpdb->query("update `".$smtptable."` set `imap_credentials`='".$bouncecredentialsjsn."'");
				$wpdb->query("update `".$fromtable."` set `bounce_email`=''");
				add_option('qmlr_bounce_check_after','0');
				add_option('qmlr_bounce_type_delete_mailbox','none');
				add_option('qmlr_bounce_type_delete_list','none');
				add_option('qmlr_wpmlrbounce_imap_credentials',$bouncecredentialsjsn);
				$bouncetoken=substr(str_shuffle('qwertyuiopasdfghjklzxcvbnm1234567890'));
				$bouncetoken .=time();
				add_option('qmlr_bounce_verifytoken',$bouncetoken);
			}
			add_option('qmlr_version_update_26','1');
		}
		if(!get_option('qmlr_version_update_27'))
		{
			$charset_collate="";
			if(!empty($wpdb->charset))
			{
			$charset_collate="default character set ".$wpdb->charset;
			}
			if(!empty($wpdb->collate))
			{
			$charset_collate .=" collate ".$wpdb->collate;
			}
			$tablecamp=$wpdb->prefix."qmlr_campaign_table";
			$qryforcamopaigntable="create table if not exists `".$tablecamp."` (
				`id` bigint not null auto_increment,
				`title` text not null,
				`description` text not null,
				`created_on` text not null,
				primary key(`id`)
				) ".$charset_collate." ENGINE=InnoDB;";
				//echo $qryforcamopaigntable;
				$wpdb->query($qryforcamopaigntable);

			$unsubscribedcampaign_table=$wpdb->prefix."qmlr_camp_uns_emails";

			$unsubscribedcampaign_table_query="create table if not exists `".$unsubscribedcampaign_table."` (
				`id` bigint not null auto_increment,
				`campaign` varchar(255) not null,
				`attempt` varchar(255) not null,
				`email` varchar(255) not null,
				`list_id` varchar(255) not null,
				`date` varchar(255) not null,
				primary key(`id`)
				) ".$charset_collate." ENGINE=InnoDB";
				$wpdb->query($unsubscribedcampaign_table_query);

			$mailsendingtable=$wpdb->prefix."quick_mail_mailsending_report";
			$wpdb->query("alter table `".$mailsendingtable."` add `campaign` varchar(255) not null after `attempt`");

			$qmlr_list_subs_sequence_table=$wpdb->prefix."qmlr_list_subs_sequence";
			$wpdb->query("alter table `".$qmlr_list_subs_sequence_table."` add `campaign` varchar(255) not null after `sequence`");

			$qmlr_subscription_mail_schedule=$wpdb->prefix."qmlr_subscription_mail_schedule";
			$wpdb->query("alter table `".$qmlr_subscription_mail_schedule."` add `campaign` varchar(255) not null after `seqid`");

			$schedular_tablename=$wpdb->prefix . 'qmlr_eml_scheedular';
			$wpdb->query("alter table `".$schedular_tablename."` add `campaign` varchar(255) after `attempt`");
			
			$newapikey=substr(str_shuffle('zasdfghjklzxcvbnmqwertyuiopQWERTYUIOPASDFGHJKLZXCVBNM@1234567890'),1,20); 
			 $newapikey="mleng:".$newapikey;
			 $pref="wp_quick_mlr_";
			update_option($pref."list_api_key",$newapikey);
			add_option('qmlr_version_update_27','1');
		}
		if(!get_option('qmlr_version_update_34'))
		{
			add_option('wp_quick_mlr_async_cron_mailer', 1);
			add_option('qmlr_version_update_34', 1);
		}
		if(!get_option('qmlr_version_update_35'))
		{
			$lists_table =$wpdb->prefix."wquick_mail_list_records";
			$wpdb->query("alter table `".$lists_table."` add `smtp` int(11) not null default 0 after `creationdate`, add `from_address` int(11) not null default 0 after `smtp`, add `priority` int(11) not null default 0 after `from_address`");
			add_option('qmlr_version_update_35', 1);
		}
		if(!get_option('qmlr_version_update_36'))
		{
			$scheedular_table =$wpdb->prefix."qmlr_eml_scheedular";
			$wpdb->query("alter table `".$scheedular_table."` modify column `mailssent` int(11) not null default 0");
			$wpdb->query("alter table `".$scheedular_table."` add `used_cust_emails` text after `mailssent`");
			add_option('qmlr_version_update_36', 1);
		}
		if(!get_option('qmlr_version_update_37'))
		{		
			$smtptable=$wpdb->prefix."quick_mail_smtp_settings";					
			$wpdb->query("ALTER TABLE `quick_mail_smtp_settings` ADD `imap_credentials` TEXT NOT NULL after `encryption`");
			add_option('qmlr_version_update_37', 1);
		}
	}
}
?>