<?php
if (isset($_SERVER['HTTP_ORIGIN'])) {

	$fp = fopen('origin.txt', 'r');
	if (filesize('origin.txt') > 0) {
		$origindata = fread($fp, filesize('origin.txt'));
		$origindataarr = explode(',', $origindata);
		if (in_array($_SERVER['HTTP_ORIGIN'], $origindataarr) || in_array('*', $origindataarr)) {
			header("Access-Control-Allow-Origin: " . $_SERVER['HTTP_ORIGIN'] . "");
		}
		fclose($fp);
	}
}


if (isset($_POST['wpqmlinsertdatatolist']) || isset($_POST['wqrmsubscriber']) || isset($_POST['wqmlrsearchpeople'])) { //sending mails
	$path = preg_replace('/wp-content(?!.*wp-content).*/', '', __DIR__);
	require($path . 'wp-load.php');


	$ipaddress = '';
	if (isset($_SERVER['HTTP_CLIENT_IP']))
		$ipaddress = $_SERVER['HTTP_CLIENT_IP'];
	else if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
		$ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
	else if (isset($_SERVER['HTTP_X_FORWARDED']))
		$ipaddress = $_SERVER['HTTP_X_FORWARDED'];
	else if (isset($_SERVER['HTTP_FORWARDED_FOR']))
		$ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
	else if (isset($_SERVER['HTTP_FORWARDED']))
		$ipaddress = $_SERVER['HTTP_FORWARDED'];
	else if (isset($_SERVER['REMOTE_ADDR']))
		$ipaddress = $_SERVER['REMOTE_ADDR'];
	else
		$ipaddress = 'UNKNOWN';



	if (current_user_can('administrator')) {

		global $wpdb;
		$listtable = $wpdb->prefix . 'wquick_mail_list_records';
		$listemailtable = $wpdb->prefix . 'quick_mail_email_lists';
		$listid = $_POST['listid'];
		$listname = $_POST['listname'];
		$email = $_POST['subscriberemail'];
		$name = $_POST['subscribername'];
		$datethis = date('d-M-Y h:ia');

		if ((isset($_POST['wpqmlinsertdatatolist']) && filter_var($email, FILTER_VALIDATE_EMAIL)) || isset($_POST['wqrmsubscriber']) || isset($_POST['wqmlrsearchpeople'])) {
			// echo $_POST['wqmlrsearchpeople'];
			$showtable = 1;
			if (isset($_POST['wpqmlinsertdatatolist'])) {
				$checkavlblity = $wpdb->get_row($wpdb->prepare("select email from " . $listemailtable . " where listid=%d and email=%s", array($listid, $email)));

				if (!$checkavlblity || $_POST['updateuser'] != '0') {
					if ($_POST['updateuser'] != '0') {
						$update = $wpdb->query($wpdb->prepare("update " . $listemailtable . " set name=%s,email=%s,ipadr=%s where id=%d", array($name, $email, $ipaddress, (int)$_POST['updateuser'])));
					} else {
						$byadminjsn = base64_encode(json_encode(array('byadmin' => 1)));

						$byadminjsn .= '@admin@';

						$in = $wpdb->query($wpdb->prepare("insert into " . $listemailtable . " (id,listid,name,email,exf,ipadr,date) values (%d,%s,%s,%s,%s,%s,%s)", array('', $listid, $name, $email, $byadminjsn, $ipaddress, $datethis)));
					}
				} else {
					$showtable = 0;
				}

				$up = $wpdb->query($wpdb->prepare("update " . $listtable . " set title=%s where id=%d", array($listname, $listid)));
			}

			if (isset($_POST['wqrmsubscriber'])) {
				$del = $wpdb->query($wpdb->prepare("delete from " . $listemailtable . " where id=%d", array($_POST['wqrmsubscriber'])));
			}

			if ($showtable == 1) {
				echo
				"
		<table class='table table-striped'>
		<thead>
      <tr><th>#</th> <th>Name</th> <th>Email</th><th>IP</th> <th>Added By</th><th>Custom Data</th><th>Added On</th> <th>Action</th></tr></thead>
    <tbody id='loadinglistqml'>
		
		";

				$searchpeople = "";
				if (isset($_POST['wqmlrsearchpeople'])) {
					if (current_user_can('administrator')) {
						$getallemails = $wpdb->get_results("select * from " . $listemailtable . " where listid=" . $listid . " and (name like '%" . $_POST['wqmlrsearchpeople'] . "%' or email like '%" . $_POST['wqmlrsearchpeople'] . "%')");
					}
				} else {
					if ($_POST['pagecount'] == '0') {
						$getallemails = $wpdb->get_results($wpdb->prepare("select * from " . $listemailtable . " where listid=%d order by id desc", array($listid)));
					} else {
						$getallemails = $wpdb->get_results($wpdb->prepare("select * from " . $listemailtable . " where id<%d and listid=%d order by id desc", array($_POST['pagecount'], $listid)));
					}
				}


				$datacount = 0;
				$lastid = 0;
				$hashcount = $_POST['hashcount'];
				foreach ($getallemails as $subs) {

					$datacount++;
					$hashcount++;

					$exf = $subs->exf;

					$exf = str_replace('@subs@', '', $exf);
					$exf = str_replace('@admin@', '', $exf);
					$exf = str_replace('@api@', '', $exf);
					$exf = base64_decode($exf);

					if (strpos($subs->exf, '@admin@') === 0 || strpos($subs->exf, '@admin@') > 0) {
						//echo "<script>alert('".strpos($subs->exf,'@admin@')."')</script>";
						$detail = 'Admin';
					} elseif (strpos($subs->exf, '@subs@') === 0 || strpos($subs->exf, '@subs@') > 0) {
						$detail = 'Subscription Form';
					} else {
						$detail = 'API';
					}

					if ((strlen($exf) > 14 && $detail == 'Admin') || (strlen($exf) > 2 && $detail != 'Admin')) {
						$exfbtn = "<button class='btn btn-default' onclick='showHideCustomSubscriberData(1," . $subs->id . ")'>View Custom Data</button>";
					} else {
						$exfbtn = "<button class='btn btn-default' disabled>View Custom Data</button>";
					}




					echo "<tr><td>" . $hashcount . "</td> <td id='wqmlemlnmsingle" . $subs->id . "'>" . $subs->name . "</td> <td id='wqmlemlemlsingle" . $subs->id . "'>" . $subs->email . "</td><td>" . $subs->ipadr . "</td><td>" . $detail . "</td><td>" . $exfbtn . "</td><td>" . $subs->date . "</td><th><button class='btn btn-info wqbtnspc' onclick='wqUpdateSubsFromList(" . $subs->id . ")'><span class='glyphicon glyphicon-pencil'></span></button><button class='btn btn-danger' onclick='wqRemoveSubscrierFromList(" . $subs->id . ")'><span class='glyphicon glyphicon-trash'></span></button></th></tr>";

					if (!isset($_POST['wqmlrsearchpeople'])) {
						if ($datacount == 5) {
							$lastid = $subs->id;
							$wplistid = $listid;
							break;
						}
					}
				}

				$subsnumbercounnt = $wpdb->get_var($wpdb->prepare("select count(id) from " . $listemailtable . " where listid=%s", array($listid)));

				echo "<tr><td colspan=10><center><strong>Total Number Of Subscribers In This List " . $subsnumbercounnt . "</strong></center></td></tr>";

				echo "<tr><td colspan=10><ul class='pager'>";

				if ($_POST['pagecount'] > 0) {
					echo '<script type="text/javascript">
            function goBack() {
              window.history.back();
                  }
                </script>';
					echo '<li class="previous" onclick="goBack()" style="cursor:pointer"><a><strong>Previous</strong></a></li>';
				}

				if ($datacount == 5) {
					echo "<li class='next' style='cursor:pointer;'><a href='" . add_query_arg(array('pagecount' => $lastid, 'hashcount' => $hashcount, 'wqlistid' => $listid), $_POST['listpageurl']) . "'><strong>Next</strong></a></li>";
				}

				echo "</ul></td></tr>";

				echo "</tbody></table>";
			} else {
				echo 2;
			}
		}
	}
}

if (isset($_POST['storefromcsv'])) {
	set_time_limit(0);
	$path = preg_replace('/wp-content(?!.*wp-content).*/', '', __DIR__);
	require($path . 'wp-load.php');
	require_once("listfunc.php");
	$ob = new wpQuickSaveList();
	echo $ob->save_list_settings();
}
if (isset($_POST['wqviewlists']) && isset($_POST['api_auth_key'])) {
	$path = preg_replace('/wp-content(?!.*wp-content).*/', '', __DIR__);
	require($path . 'wp-load.php');
	$apikey = $_POST['api_auth_key'];
	$pref = "wp_quick_mlr_";
	if ((get_option($pref . "list_api_key") == $apikey) && (get_option($pref . 'allow_lists_access_thirdparty') == '1')) {
		require_once("listfunc.php");
		$listfuncob = new wpQuickSaveList();
		echo json_encode(array("status" => true, "data" => $listfuncob->getAllListsForAPI()));
	} else {
		echo json_encode(array("status" => false, "data" => "", "error" => "Unable to validate request"));
	}
}

if (isset($_POST['wqviewleads']) && isset($_POST['api_auth_key'])) {
	$path = preg_replace('/wp-content(?!.*wp-content).*/', '', __DIR__);
	require($path . 'wp-load.php');
	$apikey = $_POST['api_auth_key'];
	$pref = "wp_quick_mlr_";
	if ((get_option($pref . "list_api_key") == $apikey) && (get_option($pref . 'allow_leads_access_thirdparty') == '1')) {
		require_once("listfunc.php");
		$listfuncob = new wpQuickSaveList();
		$list_id = $listfuncob->doEncDec($_POST['list_id'], 'dec');
		if ($listfuncob->hasList($list_id)) {
			$count = (isset($_POST['leads_count'])) ? $_POST['leads_count'] : 10;
			$data = $listfuncob->getAllLeadsForAPI($list_id, $count);
			echo json_encode(array("status" => true, "data" => $data));
		} else {
			echo json_encode(array("status" => false, "data" => "", "error" => "List not found"));
		}
	} else {
		echo json_encode(array("status" => false, "data" => "", "error" => "Unable to validate request"));
	}
	die();
}

if (isset($_POST['wqaddsubscriber'])) {

	$path = preg_replace('/wp-content(?!.*wp-content).*/', '', __DIR__);
	require($path . 'wp-load.php');


	$ipaddress = '';
	if (isset($_SERVER['HTTP_CLIENT_IP']))
		$ipaddress = $_SERVER['HTTP_CLIENT_IP'];
	else if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
		$ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
	else if (isset($_SERVER['HTTP_X_FORWARDED']))
		$ipaddress = $_SERVER['HTTP_X_FORWARDED'];
	else if (isset($_SERVER['HTTP_FORWARDED_FOR']))
		$ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
	else if (isset($_SERVER['HTTP_FORWARDED']))
		$ipaddress = $_SERVER['HTTP_FORWARDED'];
	else if (isset($_SERVER['REMOTE_ADDR']))
		$ipaddress = $_SERVER['REMOTE_ADDR'];
	else
		$ipaddress = 'UNKNOWN';

	global $wpdb;
	$listemailtable = $wpdb->prefix . 'quick_mail_email_lists';

	if (isset($_POST['formid'])) {
		$substable = $wpdb->prefix . "quick_mailer_subscription_settings";
		$subsdata = $wpdb->get_row($wpdb->prepare("select * from " . $substable . " where id=%d", array($_POST['formid'])));

		$exfdetailbase = $_POST["wqexfhiddendata"];

		$newjsndata = "";
		$exferr = 0;

		if ($exfdetailbase != 0 && $exfdetailbase != '') {
			$exfdatajsnstr = base64_decode($exfdetailbase);
			$exfdatajsnarr = explode("@jsnbrk@", $exfdatajsnstr);

			foreach ($exfdatajsnarr as $jsn) {
				try {
					$jsnparsedata = json_decode($jsn);
					if (isset($jsnparsedata->name)) {
						$exfvaluefromeachfield = $jsnparsedata->uniqueid;

						if (strlen($exfvaluefromeachfield) < 1) {
							$exferr = 1;
						}

						$newjsnob = [
							"name" => $jsnparsedata->name,
							"id" => $jsnparsedata->uniqueid,
							"data" => $exfvaluefromeachfield
						];
					}

					$newjsnob = json_encode($newjsnob);
					$newjsndata .= $newjsnob . "@jsnbrk@";
				} catch (Exception $e) {
					// Handle the exception if needed.
				}
			}

			$newjsndata = base64_encode($newjsndata);
		}
		function displayPage($flag)
		{
			$data = '';
			$image = '';
			if ($flag == 5) {
				$image = '<svg xmlns="http://www.w3.org/2000/svg" class="text-success" width="75" height="75" fill="currentColor" class="bi bi-check-circle-fill" viewBox="0 0 16 16">
				<path d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zm-3.97-3.03a.75.75 0 0 0-1.08.022L7.477 9.417 5.384 7.323a.75.75 0 0 0-1.06 1.06L6.97 11.03a.75.75 0 0 0 1.079-.02l3.992-4.99a.75.75 0 0 0-.01-1.05z" />
			</svg>';
				$data = '<h1>Thank You!</h1>
				<p>We\'ve send the link to your inbox. Thank you for connecting with us. </p>';
			} else if ($flag == 1) {
				$image = '<svg xmlns="http://www.w3.org/2000/svg" class="text-danger" width="75" height="75" fill="currentColor" class="bi bi-x-circle-fill" viewBox="0 0 16 16">
			<path d="M8 0a8 8 0 1 0 8 8A8 8 0 0 0 8 0zM4.293 4.293a.75.75 0 0 1 1.06 0L8 6.94l2.646-2.647a.75.75 0 0 1 1.06 1.06L9.06 8l2.647 2.646a.75.75 0 0 1-1.06 1.06L8 9.06l-2.646 2.647a.75.75 0 0 1-1.06-1.06L6.94 8 4.293 5.354a.75.75 0 0 1 0-1.06z"/>
		</svg>';
				$data = '<h1 color="red">Invalid Name!</h1>
				<p>Please enter valid name. </p>';
			} else if ($flag == 2) {
				$image = '<svg xmlns="http://www.w3.org/2000/svg" class="text-danger" width="75" height="75" fill="currentColor" class="bi bi-x-circle-fill" viewBox="0 0 16 16">
			<path d="M8 0a8 8 0 1 0 8 8A8 8 0 0 0 8 0zM4.293 4.293a.75.75 0 0 1 1.06 0L8 6.94l2.646-2.647a.75.75 0 0 1 1.06 1.06L9.06 8l2.647 2.646a.75.75 0 0 1-1.06 1.06L8 9.06l-2.646 2.647a.75.75 0 0 1-1.06-1.06L6.94 8 4.293 5.354a.75.75 0 0 1 0-1.06z"/>
		</svg>';
				$data = '<h1 color="red">Invalid Email Id!</h1>
				<p>Please enter valid Email Id. </p>';
			} else if ($flag == 3) {
				$image = '<svg xmlns="http://www.w3.org/2000/svg" class="text-success" width="75" height="75" fill="currentColor" class="bi bi-check-circle-fill" viewBox="0 0 16 16">
				<path d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zm-3.97-3.03a.75.75 0 0 0-1.08.022L7.477 9.417 5.384 7.323a.75.75 0 0 0-1.06 1.06L6.97 11.03a.75.75 0 0 0 1.079-.02l3.992-4.99a.75.75 0 0 0-.01-1.05z" />
			</svg>';
				$data = '<h1>You are already a subscriber!</h1>
				<p>You are already a subscriber, Thank you for connecting with us. </p>';
			} else if ($flag == 4) {
				$image = '<svg xmlns="http://www.w3.org/2000/svg" class="text-danger" width="75" height="75" fill="currentColor" class="bi bi-x-circle-fill" viewBox="0 0 16 16">
			<path d="M8 0a8 8 0 1 0 8 8A8 8 0 0 0 8 0zM4.293 4.293a.75.75 0 0 1 1.06 0L8 6.94l2.646-2.647a.75.75 0 0 1 1.06 1.06L9.06 8l2.647 2.646a.75.75 0 0 1-1.06 1.06L8 9.06l-2.646 2.647a.75.75 0 0 1-1.06-1.06L6.94 8 4.293 5.354a.75.75 0 0 1 0-1.06z"/>
		</svg>';
				$data = '<h1 col="red">Please Enter All Required Data!</h1>
				<p>Please enter all required data. You missed some data to enter.</p>';
			} else {
				$image = '<svg xmlns="http://www.w3.org/2000/svg" class="text-danger" width="75" height="75" fill="currentColor" class="bi bi-x-circle-fill" viewBox="0 0 16 16">
			<path d="M8 0a8 8 0 1 0 8 8A8 8 0 0 0 8 0zM4.293 4.293a.75.75 0 0 1 1.06 0L8 6.94l2.646-2.647a.75.75 0 0 1 1.06 1.06L9.06 8l2.647 2.646a.75.75 0 0 1-1.06 1.06L8 9.06l-2.646 2.647a.75.75 0 0 1-1.06-1.06L6.94 8 4.293 5.354a.75.75 0 0 1 0-1.06z"/>
		</svg>';
				$data = '<h1>Something went wrong!</h1>
				<p>Please try again.</p>';
			}

			return '<!DOCTYPE html>
						<html lang="en">

						<head>
							<meta charset="UTF-8">
							<meta http-equiv="X-UA-Compatible" content="IE=edge">
							<meta name="viewport" content="width=device-width, initial-scale=1.0">
							<title>Thank you</title>
							<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0/dist/css/bootstrap.min.css" rel="stylesheet">
						</head>

						<body>
							<div class="vh-100 d-flex justify-content-center align-items-center">
								<div>
									<div class="mb-4 text-center">
										' . $image . '
									</div>
									<div class="text-center">
										' . $data . '
										<a href="javascript:history.go(-1)"><button class="btn btn-primary">Go Back</button></a>
									</div>
								</div>
						</body>

						</html>';
		}


		$exfdata = "";
		$exfdata = $newjsndata;

		$exfdata .= '@subs@';
		$listid = $_POST['listid'];
		$email = $_POST['subscriberemail'];
		$name = htmlentities($_POST['subscribername']);
		$datethis = date('d-M-Y h:ia');
		if (($subsdata->name == '1') && (strlen($name) < 1)) {
			echo displayPage(1);
		} elseif (($subsdata->email == '1') && (!filter_var($email, FILTER_VALIDATE_EMAIL))) {
			echo displayPage(2);
		} elseif ($exferr > 0) {
			echo displayPage(3);
		} else {
			$checkavlblity = $wpdb->get_row($wpdb->prepare("select email from " . $listemailtable . " where listid=%d and email=%s", array($listid, $email)));
			if (!$checkavlblity) {
				$in = $wpdb->query($wpdb->prepare("insert into " . $listemailtable . " (id,listid,name,email,exf,ipadr,date) values (%d,%s,%s,%s,%s,%s,%s)", array('', $listid, $name, $email, $exfdata, $ipaddress, $datethis)));
				// echo 5;
				//sequencer call
				require_once('subssequencefunc.php');
				$sqob = new Subssequencefunc();
				$sqob->composeOrScheduleSubscriptionMail($listid, $email, $name);

				$parts = explode('@qmlrbrk@', $subsdata->exfs);

				if (count($parts) == 2) {
					$encodedRedirect = $parts[1];
					$decodedRedirect = base64_decode($encodedRedirect);
					// Now, decode the JSON data
					$redirect = json_decode($decodedRedirect, true);
					if ($redirect['redirect']) {
						header('Location: ' . $redirect['url']);
						exit;
					} else {
						echo displayPage(5);
						exit;
					}
				}
			} else {
				echo displayPage(3);
			}
		}
	} elseif (isset($_POST['api_auth_key'])) {

		$apikey = $_POST['api_auth_key'];
		$pref = "wp_quick_mlr_";
		$valid_subscriber_api_request = false;
		if (get_option($pref . "list_api_key") == $apikey) {
			require_once("listfunc.php");
			$listfuncob = new wpQuickSaveList();
			$listid = $listfuncob->doEncDec($_POST['list_id'], 'dec');

			if (is_numeric($listid) && $listfuncob->hasList($listid)) {
				$valid_subscriber_api_request = true;
				$email = $_POST['email'];
				if (filter_var($email, FILTER_VALIDATE_EMAIL)) {
					$name = htmlentities($_POST['name']);
					$exf = $_POST;
					if (isset($exf['name'])) {
						unset($exf['name']);
					}
					if (isset($exf['email'])) {
						unset($exf['email']);
					}
					if (isset($exf['api_auth_key'])) {
						unset($exf['api_auth_key']);
					}
					if (isset($exf['wqaddsubscriber'])) {
						unset($exf['wqaddsubscriber']);
					}
					if (isset($exf['list_id'])) {
						unset($exf['list_id']);
					}

					$dont_store = false;
					if (isset($_POST['dont_store'])) {
						if ($_POST['dont_store'] == '1') {
							$dont_store = true;
							echo json_encode(array('added' => false, 'valid' => true, 'cause' => 'Requested with the parameter `dont_store` with value `true`'));
							die();
						}

						unset($_POST['dont_store']);
					}

					$exfdata = "";
					if (count($exf) > 0) {
						//name:jsnparsedata.name,id:jsnparsedata.uniqueid,data:exfvaluefromeachfield
						foreach ($exf as $index => $edata) {
							$exfdata .= json_encode(array('name' => $index, 'id' => $index, 'data' => $edata));
							$exfdata .= "@jsnbrk@";
						}
						$exfdata = base64_encode($exfdata);
					}
					$exfdata .= "@api@";

					$checkavlblity = $wpdb->get_row($wpdb->prepare("select email from " . $listemailtable . " where listid=%d and email=%s", array($listid, $email)));
					if (!$checkavlblity) {
						$in = $wpdb->query($wpdb->prepare("insert into " . $listemailtable . " (id,listid,name,email,exf,ipadr,date) values (%d,%s,%s,%s,%s,%s,%s)", array('', $listid, $name, $email, $exfdata, $ipaddress, date('d-M-Y h:ia'))));
						echo json_encode(array('added' => true, 'valid' => true, 'cause' => ''));
						//sequencer call
						require_once('subssequencefunc.php');
						$sqob = new Subssequencefunc();
						$sqob->composeOrScheduleSubscriptionMail($listid, $email, $name);
					} else {
						echo json_encode(array('added' => false, 'valid' => true, 'cause' => 'Already Subscriber'));
					}
				} else {
					echo json_encode(array('added' => false, 'valid' => true, 'cause' => 'Invalid Email'));
				}
			}
		}
		if (!$valid_subscriber_api_request) {
			echo json_encode(array('added' => false, 'valid' => false, 'cause' => 'Invalid Authentication Data Provided.'));
		}
	}
}
if (isset($_POST['loadexfdatabyid'])) {
	$path = preg_replace('/wp-content(?!.*wp-content).*/', '', __DIR__);
	require($path . 'wp-load.php');

	if (current_user_can('administrator')) {
		global $wpdb;
		$table = $wpdb->prefix . "quick_mail_email_lists";
		$basedata = $wpdb->get_row($wpdb->prepare("select exf from " . $table . " where id=%d", array($_POST['loadexfdatabyid'])));
		if (strlen($basedata->exf) > 4) {


			$basedataexf = str_replace("@subs@", "", $basedata->exf);

			$basedataexf = str_replace("@admin@", "", $basedataexf);

			$basedataexf = str_replace("@api@", "", $basedataexf);

			$basedataexf = base64_decode($basedata->exf);

			$detail = explode("@jsnbrk@", $basedataexf);

			echo "<div class='table-responsive'>";
			echo "<table class='table table-striped'><thead><tr>";

			$radioarr = array();

			foreach ($detail as $data) {
				$data = json_decode($data);

				if (isset($data->id)) {
					$extra = "";
					if (strpos($data->id, "qmlrradio") > 0) {
						$dataidd = $data->id;

						$dataidd = str_replace("wqmlrjsnunique", "", $dataidd);
						$dataidd = str_replace("qmlrradio", "", $dataidd);

						$extra = "(Radio ID: " . $dataidd . ")";
					}
					echo "<th>" . $data->name . " " . $extra . "</th>";
				}
			}
			echo "</tr></thead>";
			echo "<tbody><tr>";
			foreach ($detail as $data) {

				$data = json_decode($data);
				if (isset($data->data)) {
					echo "<td>" . htmlentities($data->data) . "</td>";
				}
			}
			echo "</tr></tbody>";
			echo "</table></div>";
		}
	}
}


//Email sequencer
if (isset($_POST['rwqmlr'])) {
	$path = preg_replace('/wp-content(?!.*wp-content).*/', '', __DIR__);
	require($path . 'wp-load.php');


	global $wpdb;
	$table = $wpdb->prefix . 'qmlr_subscription_mail_schedule';
	$list_table = $wpdb->prefix . "quick_mail_email_lists";

	$getdata = $wpdb->get_row($wpdb->prepare("select * from " . $table . " where stoken=%s", array($_POST['rtoken'])));

	if ($getdata) {
		//$requrl=$_POST['rurl'];
		if (isset($_SERVER['HTTPS'])) {
			$requrl = 'https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
		} else {
			$requrl = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
		}

		$smtpid = $getdata->smtpid;
		$fromid = $getdata->fromid;
		$listid = $getdata->listid;
		$campaign = $getdata->campaign;

		$newadded = $getdata->extraemails;

		$emlcntntarr = explode('@wqmlbrk@', $getdata->sentdata);

		$subject = $emlcntntarr[0];
		$body = $emlcntntarr[1];

		$spintext = $getdata->spintext;
		$spinurl = $getdata->spinurl;

		$unsubtext = $emlcntntarr[2];

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $requrl);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, true);

		$listidarr = explode('@', trim($listid, '@'));
		for ($j = 0; $j < count($listidarr); $j++) {
			$listidarr[$j] = "'" . $listidarr[$j] . "'";
		}

		$doesexist_email_in_list = 0;
		if (in_array("'all'", $listidarr)) {
			$subname = $wpdb->get_var($wpdb->prepare("select name from " . $wpdb->prefix . "quick_mail_email_lists where email=%s and name not in ('Imported From CSV')", array($newadded)));
			$doesexist_email_in_list = $wpdb->get_var($wpdb->prepare("select count(`id`) from " . $wpdb->prefix . "quick_mail_email_lists where email=%s", array($newadded)));
		} else {
			$subname = $wpdb->get_var($wpdb->prepare("select name from " . $wpdb->prefix . "quick_mail_email_lists where email=%s and listid in (" . trim(implode(',', $listidarr), ',') . ") and name not in ('Imported From CSV')", array($newadded)));

			$doesexist_email_in_list = $wpdb->get_var($wpdb->prepare("select count(`id`) from " . $wpdb->prefix . "quick_mail_email_lists where email=%s and listid in (" . trim(implode(',', $listidarr), ',') . ")", array($newadded)));
		}
		if ($doesexist_email_in_list < 1) {
			goto delschedulelbl;
		}
		$namearr = explode(" ", $subname);
		$namearrlen = count($namearr);
		if ($namearrlen > 0) {
			$subject = str_replace("{name}", $subname, $subject);
			$subject = str_replace("{first_name}", $namearr[0], $subject);
			$subject = str_replace("{last_name}", $namearr[$namearrlen - 1], $subject);

			$body = str_replace("{name}", $subname, $body);
			$body = str_replace("{first_name}", $namearr[0], $body);
			$body = str_replace("{last_name}", $namearr[$namearrlen - 1], $body);
		} else {
			$subject = str_replace("{name}", "", $subject);
			$subject = str_replace("{first_name}", "", $subject);
			$subject = str_replace("{last_name}", "", $subject);


			$body = str_replace("{name}", "", $body);
			$body = str_replace("{first_name}", "", $body);
			$body = str_replace("{last_name}", "", $body);
		}

		$data = array(
			'wpqmlrsubmit' => 1,
			'smailvalidtoken' => $_POST['rtoken'],
			'wpqmlrsmtp' => $smtpid,
			'wpqmlrsendfrom' => $fromid,
			'wpqmlremailselect' => $listid,
			'wpqmlrcampaign' => $campaign,
			'wpqmlremailmanual' => $newadded,
			'wpqmlremailsub' => $subject,
			'wpqmlrmlbody' => $body,
			'wpqmlrspintext' => $spintext,
			'wpqmlrmlspinurl' => $spinurl,
			'unsubtext' => $unsubtext,
			'sequence' => 1,
		);

		//print_r($data);

		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		$output = curl_exec($ch);

		//echo $output;

		$info = curl_getinfo($ch);
		curl_close($ch);

		delschedulelbl:
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $_POST['apiurl']);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, true);
		$deldata = array(
			'remschedule' => $_POST['rtoken'],
			'remurl' => $_POST['rurl']
		);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $deldata);
		$output = curl_exec($ch);
		//echo $output;
		$info = curl_getinfo($ch);
		curl_close($ch);
	}
}

if (isset($_POST['smailvalidtoken'])) {
	$path = preg_replace('/wp-content(?!.*wp-content).*/', '', __DIR__);
	require($path . 'wp-load.php');

	global $wpdb;
	$table = $wpdb->prefix . 'qmlr_subscription_mail_schedule';

	$getdata = $wpdb->get_row($wpdb->prepare("select id from " . $table . " where stoken=%s", array($_POST['smailvalidtoken'])));

	//print_r($getdata);

	if ($getdata) {
		require_once("composemailfunction.php");
		$ob = new wpquickmailcomposemail();
		$ob->composeWpqMail();

		$update = $wpdb->query($wpdb->prepare("update " . $table . " set status=%s where id=%d", array('2', $getdata->id)));
	}
}
