<?php
use BounceMailHandler\BounceMailHandler;
function qmlrRunDebugBounceCheckEcho()
{
/*~ index.php
/*
 * This is an example script to work with PHPMailer-BMH (Bounce Mail Handler).
 */
$time_start = microtime_float();
require_once 'vendor/autoload.php';
require_once("callback_echo.php");
// Use ONE of the following -- all echo back to the screen
//require_once 'callback_echo.php';
//require_once('callback_database.php'); // NOTE: Requires modification to insert your database settings
//require_once('callback_csv.php');      // NOTE: Requires creation of a 'logs' directory and making writable
// testing examples
$bmh = new BounceMailHandler();
$bmh->actionFunction = 'callbackAction'; // default is 'callbackAction'
$bmh->verbose = BounceMailHandler::VERBOSE_SIMPLE; //BounceMailHandler::VERBOSE_SIMPLE; //BounceMailHandler::VERBOSE_REPORT; //BounceMailHandler::VERBOSE_DEBUG; //BounceMailHandler::VERBOSE_QUIET; // default is BounceMailHandler::VERBOSE_SIMPLE
//$bmh->useFetchStructure  = true; // true is default, no need to specify
//$bmh->testMode           = false; // false is default, no need to specify
//$bmh->debugBodyRule      = false; // false is default, no need to specify
//$bmh->debugDsnRule       = false; // false is default, no need to specify
//$bmh->purgeUnprocessed   = false; // false is default, no need to specify
$bmh->disableDelete = false; // false is default, no need to specify
/*
 * for local mailbox (to process .EML files)
 */
//$bmh->openLocal('/home/email/temp/mailbox');
//$bmh->processMailbox();
/*
 * for remote mailbox
 */
$credentials=$GLOBALS['qmlr_imap_credentials'];
$bmh->mailhost =$credentials->host; // your mail server
$bmh->mailboxUserName = $credentials->username; // your mailbox username
$bmh->mailboxPassword = $credentials->password; // your mailbox password
$bmh->port = $credentials->port; // the port to access your mailbox, default is 143
$bmh->service = 'imap'; // the service to use (imap or pop3), default is 'imap'
$bmh->serviceOption = $credentials->encryption; // the service options (none, tls, notls, ssl, etc.), default is 'notls'
$bmh->boxname = 'INBOX'; // the mailbox to access, default is 'INBOX'
//$bmh->moveHard           = true; // default is false
//$bmh->hardMailbox        = 'INBOX.hardtest'; // default is 'INBOX.hard' - NOTE: must start with 'INBOX.'
//$bmh->moveSoft           = true; // default is false
//$bmh->softMailbox        = 'INBOX.softtest'; // default is 'INBOX.soft' - NOTE: must start with 'INBOX.'
//$bmh->deleteMsgDate      = '2009-01-05'; // format must be as 'yyyy-mm-dd'
/*
 * rest used regardless what type of connection it is
 */
$bmh->openMailbox();
$bmh->processMailbox();

echo '<hr style="width:200px;" />';

$time_end = microtime_float();
$time = $time_end - $time_start;

echo 'Seconds to process: ' . $time . '<br />';

/**
 * @return float
 */
}
function microtime_float(): float
{
    list($usec, $sec) = \explode(' ', \microtime());
    return (float) $usec + (float) $sec;
}
?>