<?php 
class DelaySaveSettings
{
	var $originfile;
	
	function __construct()
	{
		$thisfile=__FILE__;
		$this->originfile=str_replace("delaysettings_func.php","origin.txt",$thisfile);
	}
	function loadDelaySettingsPage()
	{
		self::delayMailsSave();
		$pref="wp_quick_mlr_";
		require_once('delay_mail_settings.php');

	}
	function delayMailsSave()
	{
		if (isset($_POST['delay_settings_save_settings'])) {
			$pref="wp_quick_mlr_";
			$chunksize = $_POST['chunk-size'];
			$delaysec = $_POST['wpquickmlr-delaysec'];
			$scheduletime = $_POST['schedule-chunk'];
			$contactinfo=stripcslashes($_POST['wq_template_contact']);
			$origindata=$_POST['qmlrcrsorigins'];
			$newapikey=$_POST['wqmlrlistapikey'];

			$cron_type= $_POST['cron-type'];
			$cron_delay= $_POST['wpquickmlr-delaysec-cron'];
			$async_cron_mailer= (isset($_POST['wpquickmlr-async_cron_mailer']))? 1: 0;

		    $origindata=str_replace(" ","",$origindata);
			update_option('wqmlr_cross_origins',$origindata);

			update_option($pref.'send_noof_mail_at_chunk',$chunksize);
			update_option($pref.'compose_delay_sec',$delaysec);
			update_option($pref.'send_noof_mail_sch_min',$scheduletime);
			update_option($pref."list_api_key",$newapikey);
			update_option($pref."cron_type", $cron_type);
			update_option($pref.'cron_delay_sec', $cron_delay);
			update_option($pref.'async_cron_mailer', $async_cron_mailer);
			
			//update_option('qmlr_bounce_check_after',$_POST['bouncecheckafter']);
			update_option('qmlr_bounce_type_delete_mailbox',$_POST['qmlr_bounce_type_delete_mailbox']);
			update_option('qmlr_bounce_type_delete_list',$_POST['qmlr_bounce_type_delete_list']);

			$imap_credentialsjsn=json_encode(array('host'=>$_POST['dwpqmlr-imaphost'],'port'=>$_POST['dwpqmlr-imapport'],'encryption'=>$_POST['dwpqmlr-imapencryption'],'username'=>$_POST['dwpqmlr-imapusername'],'password'=>$_POST['dwpqmlr-imappassword'],'service'=>'imap','return_path'=>$_POST['dwpqmlr-returnpath']));
		  
			update_option('qmlr_wpmlrbounce_imap_credentials',$imap_credentialsjsn);

            if(isset($_POST['seoemailtext']))
            {
				update_option($pref.'redirection_page_mail_content','1');
			}				
            else
			{
				update_option($pref.'redirection_page_mail_content','0');
			}

			if(isset($_POST['allow_lists_access_thirdparty']))
			{
				update_option($pref.'allow_lists_access_thirdparty','1');
			}
			else
			{
				update_option($pref.'allow_lists_access_thirdparty','0');
			}

			if(isset($_POST['allow_leads_access_thirdparty']))
			{
				update_option($pref.'allow_leads_access_thirdparty', '1');
			}
			else
			{
				update_option($pref.'allow_leads_access_thirdparty', '0');
			}
			
			update_option($pref.'contact_template',$contactinfo);
			
			
			$fp=fopen($this->originfile,'w');
			
			fwrite($fp,$origindata);
			fclose($fp);
		}

	}
}
?>