<?php
class Wpqmlr_email_verification
{
    function __construct()
    {
        $this->pref="wp_quick_mlr_";
        $this->api_url="http://localhost/mh_zbounce/?product={product_id}";
        $this->api_secret= "MpFnKr9YGt";
    }
    function loadSetupPage()
    {
        require_once('email_verification.php');
    }
    function request($url, $data=array())
    {
        $ch=curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        $res=curl_exec($ch);
        curl_close($ch);
        return $res;
    }
    function hasAPIKey()
    {
        return true;
        /*-----Terminated------*/
        $option=$this->pref.'verifier_api_key';
        if(get_option($option))
        {
            return get_option($option);
        }
        return false;
    }
    function createAPIKey()
    {
        $option=$this->pref.'verifier_api_key';
        $api_setup=self::getAPIAuthSetup();
        if(isset($api_setup->custemail))
        {
            $url=str_replace('{product_id}', $api_setup->plugincode, $this->api_url);
            $arr= array
            (
                'register'=> 1,
                'email'=> $api_setup->custemail,
                'order_code'=> $api_setup->custorder,
                'location'=> site_url()
            );
            $res=$this->request($url, $arr);
            $res=json_decode($res);
            if(isset($res->status))
            {
                if(get_option($option))
                {
                    update_option($option, $res->data);
                }
                else
                {
                    add_option($option, $res->data);
                }
                return true;
            }
        }
        return false;
    }
    function getAPIAuthSetup()
    {
        //wp_quick_mlr_license_auth
        //wp_quick_mlr_licensed
        $pref= $this->pref;
        if(get_option($pref.'licensed') && get_option($pref.'license_auth'))
        {
            $data= json_decode(get_option($pref.'license_auth'));
            return $data;
        }
        return false;
    }
    function getCreditURL()
    {
        $auth= $this->getAPIAuthSetup();
        $url= "https://mailengine.in/mailenginecredit?licence=";
        if($auth && isset($auth->custorder))
        {
            $url .=$auth->custorder;
        }
        return $url;
    }
    function updateCredit()
    {
        //custorder
        $auth= $this->getAPIAuthSetup();
        if($auth && isset($auth->custorder))
        {
            $req= array(
                'licence'=> $auth->custorder,
                'secret'=> $this->api_secret,
            );
            $res= $this->request("https://mailengine.in/zbounceapi/GetMember", $req);
            $res= json_decode($res);
            if(isset($res->result) && isset($res->value->Credit) && is_numeric($res->value->Credit))
            {
                update_option($this->pref.'zbounce_credit', $res->value->Credit);
            }
        }
    }
    function getCredit()
    {
        $credit= (get_option($this->pref.'zbounce_credit'))? get_option($this->pref.'zbounce_credit'):0;

        return $credit;
    }
    function processValidation($emails)
    {
        $data=array('status'=>false, 'data'=> 'Unable to find license');
        $config= self::getAPIAuthSetup();
        if($config && isset($config->custorder))
        {
            $emails=json_encode(explode(',', $emails));
            $url= "https://mailengine.in/ZBounceAPI/Validate";
            $data= $this->request($url, array('licence'=>$config->custorder, 'emails'=>$emails, 'secret'=>$this->api_secret));
            $this->updateCredit();
        }
        return $data;
    }
}
?>