<?php
if(isset($_POST['wqmlrexportmails']))
{
	$path = preg_replace('/wp-content(?!.*wp-content).*/','',__DIR__);
	require($path.'wp-load.php');
	$wpdb->show_errors(); 
	
global $wpdb;
$table=$wpdb->prefix.'quick_mail_mailsending_report';							

// Build your query	
$wqqury=$_POST['type'];
$typetocheck=$_POST['qmlrqrytype'];

if($typetocheck=="attempt")
{
   $attempt=$_POST['attempt'];
   if($wqqury=='sent')
	{
		$qry="select id,email,date,time from ".$table." where status in('1','2') and attempt=%s";
	}
    elseif($wqqury=='seen')
	{
		$qry="select id,email,date,time from ".$table." where status='2' and attempt=%s";
	}
	 elseif($wqqury=='unseen')
	{
		$qry="select id,email,date,time from ".$table." where status='1' and attempt=%s";
	}
    elseif($wqqury=='pending')
	{
		$qry="select id,email,date,time from ".$table." where status='0' and attempt=%s";
	}
	elseif($wqqury=='bounced')
	{
		$qry="select id,email,error,date,time from ".$table." where status='5' and attempt=%s";
	}
	elseif($wqqury=='linkvisits')
	{
		//echo 1;
		$selectvisitedemail=$wpdb->get_results($wpdb->prepare("select visitedby from ".$wpdb->prefix."quick_mailer_links_visits where emailattempt=%s",array($attempt)));
		
		//print_r($selectvisitedemail);
		
		$sqlinvisiarr=array(0);
		foreach($selectvisitedemail as $emllist)
		{
			//echo 1;
			
			//print_r($emllist);
			
			$emlarrayforvisit=explode('@wqmlemlbrk@',$emllist->visitedby);
			
			$sqlinvisiarr=array_merge($sqlinvisiarr,$emlarrayforvisit);
			
		}
		
		for($i=0;$i<count($sqlinvisiarr);$i++)
		{
			$sqlinvisiarr[$i]="'".$sqlinvisiarr[$i]."'";
		}
		
		$sqlinvisitcomma=implode(',',array_unique($sqlinvisiarr));
		$qry="select id,email,date,time from ".$table." where  email in(".$sqlinvisitcomma.") and attempt=%s";
		
		//echo $qry;
		
	}
	elseif($wqqury=='unsubscribe')
	{
		$unstable=$wpdb->prefix.'quick_mailer_unsubscribe_users';
		$getunsemailquery=$wpdb->get_results($wpdb->prepare("select email from ".$unstable." where status=1 and attempt=%s",array($attempt)));
		
	       $unsemlarr=array();
	  
	       foreach($getunsemailquery as $getunsemail)
	      {
		  $getunsemailcollon="'".$getunsemail->email."'";
		 $unsemlarr=array_merge($unsemlarr,array($getunsemailcollon)); 
	      }
		  
		  $qry="select id,email,date,time from ".$table." where email in(".implode(',',$unsemlarr).") and attempt=%s";
	}
	elseif($wqqury=='campaign_unsubscribe')
	{
		$unstable=$wpdb->prefix.'qmlr_camp_uns_emails';
		$qry="select a.id as id,a.email as email,a.date as date,a.time as time from ".$table." as a inner join ".$unstable." as b on a.attempt=b.attempt where a.email=b.email and a.attempt=%s";	
	}
	$MyQuery=$wpdb->get_results($wpdb->prepare($qry,array($attempt)));
}
elseif($typetocheck=="campaign")
{
	if($wqqury=='sent')
	{
		$qry="select id,email,date,time from ".$table." where status in('1','2') and campaign=%s order by id desc";
	}
    elseif($wqqury=='seen')
	{
		$qry="select id,email,date,time from ".$table." where status='2' and campaign=%s order by id desc";
	}
	elseif($wqqury=='bounced')
	{
		$qry="select id,email,error,date,time from ".$table." where status='5' and campaign=%s order by id desc";
	}
	 elseif($wqqury=='unseen')
	{
		$qry="select id,email,date,time from ".$table." where status='1' and campaign=%s order by id desc";
	}
    elseif($wqqury=='pending')
	{
		$qry="select id,email,date,time from ".$table." where status='0' and campaign=%s order by id desc";
	}
	elseif($wqqury=='linkvisits')
	{
		$linksvisitstable=$wpdb->prefix."quick_mailer_links_visits";

	     $qry="select a.id as id,a.email as email,a.date as date,a.time as time,b.visitedby as visitedby from ".$table." as a inner join ".$linksvisitstable." as b on a.attempt=b.emailattempt where a.campaign=%s";
	
		$islinkvisitquery_csv=1;
	}
	elseif($wqqury=='unsubscribe')
	{
		  $unstable=$wpdb->prefix.'quick_mailer_unsubscribe_users';

		  $qry="select a.id as id,a.email as email,a.date as date,a.time as time from ".$table." as a inner join ".$unstable." as b on a.attempt=b.attempt where a.email=b.email and a.campaign=%s";	
	}
	elseif($wqqury=='campaign_unsubscribe')
	{
			$unstable=$wpdb->prefix.'qmlr_camp_uns_emails';
		    $qry="select a.id as id,a.email as email,a.date as date,a.time as time from ".$table." as a inner join ".$unstable." as b on a.campaign=b.campaign where a.attempt=b.attempt and a.email=b.email and a.campaign=%s";	
	}
	$MyQuery=$wpdb->get_results($wpdb->prepare($qry,array($_POST['campaign'])));
}

// Process report request
if (! $MyQuery) {
$Error = $wpdb->print_error();
die("The following error was found: $Error");
} else {
// Prepare our csv download

// Set header row values
$csv_fields=array();
$csv_fields[] = '#';
$csv_fields[] = 'Email';
if(isset($wqqury))
{
	if($wqqury=="bounced")
	{
		$csv_fields[]='Reason';	
	}
}
$csv_fields[] = 'Date';
$csv_fields[] = 'Time';


$output_filename = $wqqury.'-emails.csv';
$output_handle = @fopen( 'php://output', 'w' );
 
header( 'Cache-Control: must-revalidate, post-check=0, pre-check=0' );
header( 'Content-Description: File Transfer' );
header( 'Content-type: text/csv' );
header( 'Content-Disposition: attachment; filename=' . $output_filename );
header( 'Expires: 0' );
header( 'Pragma: public' );	

// Insert header row
fputcsv( $output_handle, $csv_fields );

// Parse results to csv format
foreach ($MyQuery as $Result) {
	if(isset($islinkvisitquery_csv))
	{
		
			if(!in_array($Result->email,explode("@wqmlemlbrk@",$Result->visitedby)))
			{
				continue;
			}
		
	}

	$leadArray = (array) $Result; // Cast the Object to an array
	if(isset($leadArray['visitedby']) && isset($islinkvisitquery_csv))
	{
		unset($leadArray['visitedby']);
	}
	// Add row to file
	fputcsv( $output_handle, $leadArray );
	}
 
// Close output file stream
fclose( $output_handle ); 

die();
}
}
?>