<?php
    if(!class_exists('WQMLR_live_mail_status'))
    {
        class WQMLR_live_mail_status
        {
            function __construct()
            {
                
            }
            function loadPage()
            {
                require_once("live_mail_status.php");
            }
            function getStatus($id, $type="attempt")
            {
                //$type= attempt or schedule
                global $wpdb;

                $schedular_table= $wpdb->prefix.'qmlr_eml_scheedular';
                $attempt_id= ($type==='attempt')? ((int) $id) : 0;
                $schedule_id= ($type==='schedule')? ((int) $id) : 0;
                $count_subs= 0;

                $title= "No Title";
                $sent_data= "";
                
                if($type==="schedule")
                {
                    $get_attempt= $wpdb->get_row($wpdb->prepare("select attempt, sentdata from ".$schedular_table." where id=%d", array($schedule_id)));

                    if($get_attempt)
                    {
                        $attempt_id= $get_attempt->attempt;
                        $sent_data= $get_attempt->sentdata;
                    }
                }
                else if($type==="attempt")
                {
                    $get_schedule= $wpdb->get_row($wpdb->prepare("select id from ".$schedular_table." where attempt=%s", array($attempt_id)));
                    if($get_schedule)
                    {
                        $schedule_id= $get_schedule->id;
                    }
                }

                if($schedule_id)
                {
                    $schedule= $wpdb->get_row($wpdb->prepare("select * from ".$schedular_table." where id=%d",array($schedule_id)));
                    require_once("composemailfunction.php");
                    $compose_ob= new wpquickmailcomposemail();

                    $lists= $schedule->listid;
					$extra_emails= $schedule->extraemails;

                    $schedusubscribers= $compose_ob->seqMailDescBreak($attempt_id, $lists, $extra_emails, 0, array(), true);

                    if(is_array($schedusubscribers))
                    {
                        $count_subs= count($schedusubscribers);
                        //echo "Getting count subs from here ".$count_subs;
                    }
                }

                $table= $wpdb->prefix.'quick_mail_mailsending_report';

                if(strlen($sent_data)<1 && $attempt_id>0)
                {
                    $title_get_row= $wpdb->get_row($wpdb->prepare("select `sentdata` from `".$table."` where `attempt`=%s limit 1", array($attempt_id) ));

                    if($title_get_row)
                    {
                        $sent_data= $title_get_row->sentdata;
                    }
                }

                if(strlen($sent_data)>0) 
                {
                    $sent_data= explode('@wqmlbrk@', $sent_data);
                    if(isset($sent_data[0]) && strlen($sent_data[0])>0)
                    {
                        $title= $sent_data[0];
                    }
                }

                $count_subs += $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM ".$table." WHERE attempt=%s", array($attempt_id)));

        
                //get delivered mails count
                $count_delivered= $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM ".$table." WHERE attempt=%s and (status='1' OR status='2')", array($attempt_id)));

            
                //get status of pending mails
                $count_unsent= $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM ".$table." WHERE attempt=%s and status='0'", array($attempt_id)));
            
                //seen emails 
                $count_seen= $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM ".$table." WHERE attempt=%s and status='2'", array($attempt_id)));
        
                //bounced mails   
                $count_bounce= $wpdb->get_var($wpdb->prepare("select count(*) from ".$table." where attempt=%s and status='5'", array($attempt_id)));

                //link visits
                $links_table= $wpdb->prefix.'quick_mailer_links_visits';
                $count_visit= $wpdb->get_var($wpdb->prepare("SELECT SUM(visits) FROM ".$links_table." where `emailattempt`=%s", array($attempt_id)));

                if(is_null($count_visit)|| !is_numeric($count_visit))
                {
                    $count_visit= 0;
                }
                
                $email_title= $title; 
                $arr= compact("email_title", "count_subs", "count_delivered", "count_unsent", "count_seen", "count_bounce", "count_visit", "attempt_id");

                return $arr;
            }
        }
    }

?>