<?php
    $lists= self::getAllListsByPriority();
?>
<div class="container-fluid wqmlrcontf">
<br>
	<div class="row">
	<div class="col-sm-12">
	
	  <ul class="nav nav-tabs">
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quick_mlr"><img  src="<?php echo plugins_url('image/dashboard.png',__FILE__); ?>"> Dashboard</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wqmlr_manage_smtp"><img  src="<?php echo plugins_url('image/frommails.png',__FILE__); ?>"> SMTPs</a></li>
    <li class="quickmlr-menu-tabs"><a href="admin.php?page=wqmlr_generated_links"><img  src="<?php echo plugins_url('image/links.png',__FILE__); ?>"> Links</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wqmlr_email_settings"><img  src="<?php echo plugins_url('image/frommails.png',__FILE__); ?>"> From Emails</a></li>
  <li class="active quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_lists"><img  src="<?php echo plugins_url('image/listsel.png',__FILE__); ?>"> Lists</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_compose_email"><img  src="<?php echo plugins_url('image/composemails.png',__FILE__); ?>"> Compose Mail</a></li>
   <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_mails_sent"><img  src="<?php echo plugins_url('image/mailssent.png',__FILE__); ?>"> Mails Sent</a></li>  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_schedule_records"><img  src="<?php echo plugins_url('image/scheduledmails.png',__FILE__); ?>"> Scheduled Mails</a></li>
   <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_subscription_forms"><img  src="<?php echo plugins_url('image/subscriptionforms.png',__FILE__); ?>"> Subscription Forms</a></li>
   
</ul>
<br>
	
<div class="panel panel-primary wqsettingpanel">
    <div class="panel-heading">
        <h4 class="m0">Prioritize Lists</h4>
    </div>
    <div class="panel-body">
        <div class="container-fluid">
            <div class="row lists-container-wqml">
                <div class="col-sm-6">
                    <div class="panel panel-default">
                        <div class="panel-heading"><h5 class="m0">Lists</h5></div>
                        <div class="panel-body wqmlrp-all-lists">

                            <?php 
                            $count= count($lists);
                            $hash= 0;

                            if($count<1){ echo "<h4 class='text-center' style='opacity: 0.5'>No Lists Found</h4>"; }

                            foreach($lists as $list){ ?>
                                
                                <div class="input-group each" data-position="<?php echo $count; ?>" data-id="<?php echo $list->id; ?>">
                                    <div class="input-group-addon">
                                        <strong class="hash"><?php echo ++$hash; ?></strong>
                                    </div>
                                    <p class="form-control"><?php echo $list->title; echo "&nbsp;(".(($list->subscribers>0)? $list->subscribers: "No")." Subscribers)";  ?></p>
                                    <div class="input-group-addon">
                                        <span class="glyphicon glyphicon-chevron-up direction-top" data-toggle="tooltip" title="Level up"></span>
                                        <span class="glyphicon glyphicon-chevron-down direction-bottom" data-toggle="tooltip" title="Level down"></span>
                                    </div>
                                </div>

                            <?php 
                            --$count;
                            } 
                            
                            ?>
                        </div>
                        <?php if(count($lists)>0){ ?>
                            <div class="panel-footer text-right">
                                <button class="btn btn-primary wqmlr_add_priority"><strong>Save setup</strong></button>
                            </div>
                        <?php } ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
</div>
</div>
</div>

<script>
    (function(){
        let count= <?php echo count($lists); ?>;
        let doc= document.querySelectorAll(`.wqmlrp-all-lists`)[0];
        let nodes= doc.querySelectorAll(`.each`);

        let reArrange= function(){
            let nodes= doc.querySelectorAll(`.each`);
            let ccount= count;
            let hash= 0;
            nodes.forEach(node=>{
                node.setAttribute('data-position', ccount);
                --ccount;
                ++hash;
                node.querySelectorAll(".hash")[0].innerHTML= hash;
            });
        };

        document.querySelectorAll(".wqmlr_add_priority")[0].onclick= function(){
            let form= document.createElement("form");
            form.action= "";
            form.method= "POST";
            let inp= document.createElement("input");
            inp.name= "wqmlr_add_priority";
            form.appendChild(inp);
            let jsn= {};
            let nodes= doc.querySelectorAll(`.each`);

            nodes.forEach(node=>{
                let val= node.getAttribute(`data-position`);
                let key= node.getAttribute(`data-id`);
                jsn[key]= val;
            });

            inp.value= btoa(JSON.stringify(jsn));

            document.body.appendChild(form);
            form.submit();
        };

        nodes.forEach(function(node){
            node.onclick= function(){
                nodes.forEach(function(node){ node.classList.remove('active') });
                this.classList.add('active');
            };
            let up= node.querySelectorAll(".direction-top")[0];
            let down= node.querySelectorAll(".direction-bottom")[0];

            up.onclick= function(){
                let position= parseInt(node.getAttribute('data-position'));
                if(position<count)
                {
                    let target= doc.querySelectorAll(`[data-position="${(position+1)}"]`)[0];
                    doc.insertBefore(node, target);
                }
                reArrange();
            };

            down.onclick= function(){
                let position= parseInt(node.getAttribute('data-position'));
                if(position>1)
                {
                    let target= doc.querySelectorAll(`[data-position="${(position-1)}"]`)[0];
                    doc.insertBefore(target, node);
                }
                reArrange();
            };

        });
    })()
</script>

<style>
    .lists-container-wqml
    {
        display: flex;
        justify-content: center;
    }
    .wqmlrp-all-lists
    {
        max-height: 400px;
        overflow: auto;
    }
    .wqmlrp-all-lists .each
    {
        margin-bottom: 4px;
    }
    .wqmlrp-all-lists .active
    {
        font-weight: 600;
        border: 4px solid gray;
    }
    .wqmlrp-all-lists .direction-top, .wqmlrp-all-lists .direction-bottom
    {
        display: block;
        cursor: pointer;
    }
    .wqmlrp-all-lists .direction-top
    {
        padding-bottom: 5px;
    }
</style>