<?php
if(!class_exists('quickmlr_unsb_class'))
{
	class quickmlr_unsb_class
	{
		var $pref;
		
		function __construct()
		{
			$this->pref="wp_quick_mlr_";
		}
		function qmlr_add_custom_unsubscription_page()
		{
       $my_post = array(
      'post_title'    => wp_strip_all_tags( 'Unsubscribe' ),
      'post_content'  => '[qmlr_uns_template]',
      'post_status'   => 'publish',
      'post_author'   =>  get_current_user_id(),
      'post_type'     => 'page',
       );
    
	   $link=get_option($this->pref.'unsubscribelink');
       // Insert the post into the database
	   if(!$link)
	   {
       $id=wp_insert_post( $my_post );
	   add_option($this->pref.'unsubscribelink',$id);
	   }
       }
	   
	   function qmlrUnsubscribeShortCode()
	   {
		   add_shortcode('qmlr_uns_template',array($this,'qmlrUnsubscribeFunction'));
		   add_shortcode('wq-exclude',array($this,'qmlrExcludeCallBack'));
		   add_shortcode('wq-link',array($this,'wqLinkCallback'));
		   add_shortcode('wq-uns-link',array($this,'wqUnsLinkCreate'));
		   add_shortcode('wq-contact-template',array($this,'wqContactTemplate'));
		   add_shortcode('wq-uns-campaign',array($this,'qmlrCampaignUnsubscribeLinkCreate'));
	   }
	   function qmlrCampaignUnsubscribeLinkCreate($attr,$content)
	   {
		$unsublink=get_permalink(get_option($this->pref.'unsubscribelink'));
		$content="<a href='".add_query_arg(array('qmlrunscampaignotp'=>'@replcunsubscampaigntokenqmlr@','card'=>'@replcunsubscampaignemailqmlr@','camp_card'=>'@replcunsubstokenqmlr@'),$unsublink)."'>".$content."</a>";
		return $content;
	   }
	   function wqContactTemplate()
	   {
		   return get_option($this->pref.'contact_template');
	   }
	   
	   function wqUnsLinkCreate($att,$content)
	   {
		   $unsublink=get_permalink(get_option($this->pref.'unsubscribelink'));
		   $content="<a href='".add_query_arg(array('qmlrunsubotp'=>'@replcunsubstokenqmlr@','card'=>'@replcunsubsemailqmlr@'),$unsublink)."'>".$content."</a>";
		   return $content;
	   }
	   
	   function wqLinkCallback($att,$content="")
	   {
		   global $wpdb;
		   
		   $table=$wpdb->prefix.'quick_mailer_links_visits';
		   
		   $attempt=get_option($this->pref.'mail_attempt');
		   
		   $qryshortcode=$wpdb->get_row($wpdb->prepare("select url from ".$wpdb->prefix."quick_mail_links_with_shortcode where token=%s",array($att['token'])));
		   
		   $siteurl=get_permalink(get_option($this->pref.'redirection_page_id'));
		   if(!$siteurl)
		   {
		   $siteurl=site_url();
		   }
		   
		   $encurl=$qryshortcode->url;
		   
		   if(get_option($this->pref.'only_url_shortcode')=='1')
		   {
			    $query=$wpdb->get_row($wpdb->prepare("select otp from ".$table." where link=%s and emailattempt=%s",array($encurl,$attempt)));
		        if($query)
		        {
			     $encurl=add_query_arg(array('wqmllinkredirect'=>$query->otp,'wqmlcard'=>'@wqmlemlrplcparam@'),$siteurl); 
		        }
				else
				{
			   $otp=substr(str_shuffle('abcdefghi'),1,4);
		       $otp.=substr(str_shuffle('12345'),1,substr(str_shuffle('2345'),1,1));
		 
		       $otpp=substr(str_shuffle('SAUVWXYZ1234567890'),1,5);
		       $otpp.=substr(str_shuffle('12345'),1,substr(str_shuffle('2345'),1,1));
		 
		       $otppnum=substr(str_shuffle('qmlrQMLR1234567890'),0,10);
		       $otppnum .='a';
		 
		       $otp=$otp.'-'.$otpp.'-'.$otppnum.$attempt;
			   
			   $insertq="insert into ".$table." (id,emailattempt,link,visits,visitedby,otp,exf,date) values (%d,%s,%s,%s,%s,%s,%s,%s)";
		 $inarr=array('',$attempt,$encurl,'0','',$otp,'',date('d-M-Y h:ia'));
		  $in=$wpdb->query($wpdb->prepare($insertq,$inarr));
			   
		        $encurl=add_query_arg(array('wqmllinkredirect'=>$otp,'wqmlcard'=>'@wqmlemlrplcparam@'), $siteurl);
				
				}
		   }
		   
		   if((strlen($content)>0) && (trim($content," ") !=""))
		   {
			   return "<a href='".$encurl."'>".$content."</a>";
		   }
		   else
		   {
			   return "<a href='".$encurl."'>".$qryshortcode->url."</a>";
		   }
			   
	   }
	   function qmlrExcludeCallBack($att,$content)
	   {
		  return "";
	   }
	   function qmlrUnsubscribeFunction()
	   {
		   
			  $stat=self::wqmlUnsubscribeMls(); 
		   
			  $forthiscampaign="";
			  $listorcampaign="list(s)";
			  if(isset($_GET['qmlrunscampaignotp']))
			  {
				$forthiscampaign="for this campaign";
				$listorcampaign="campaign";
			  }
		       if($stat==1)
			   {
				   $headertext="You've been unsubscribed";
				   $stattext="<div class='wpqkmlr-alerttext'>
                <strong>You've been unsubscribed and you will not receive any more emails from us ".$forthiscampaign."</strong></div>";
			   }
			   else
			   {
				   $headertext="Unsubscribe Yourself";
				   $stattext="<div class='wpqkmlr-alerttext'>
                <strong>Alert!</strong> Stop receiving emails and unsubscribe from following ".$listorcampaign.".
                </div><br>
            <div class='wpqkmlr-wall'>
                <form class='wpqkmlr-form' action='' method='post'>
                <b><center>".$stat."</center></b>
                <br>
            <center><input type='submit' class='wpqkmlr-button' name='wpqmlr-unsubs' value='Unsubscribe' onclick='wqunsubsrequest()' >
            <button type='button' class='wpqmlr-cancel' onclick='wqcancelrequest()'>Cancel</button></center>

                </form>
            </div>";
			   }
		   
$body="
<script type='text/javascript'>function wqcancelrequest(){window.location.href='".home_url()."';}</script>
<div class='wpqkmlr-container'>   
    <div class='row'><br><br><br>
        <div class=''>
            <div class='wpqkmlr-main wpqkmlr-primary'>
               <div class='wpqmlrheading'>
            <center><h3 class='wpqkmlr-m0' style='color:white'>".$headertext."</h3></center></div>
            <div class='wpqkmlr-body'>
                  ".$stattext."  
            </div>
        </div>
        </div>
    </div>
</div>";
$style="
<style type='text/css'>
.wpqkmlr-container{
    max-width: 500px;
    margin: 0 auto;
}
.wpqkmlr-alerttext{
    border: 1px solid #e89f30;
    border-radius: 5px;  
    padding: 13px 20px;
    background-color: #de972bb5;
}
.wpqkmlr-button,.wpqmlr-cancel{  
    border: none;
    text-align: center;
    text-decoration: none;
    display: inline-block;
    font-size: 16px;
    margin: 4px 2px;
    cursor: pointer;
    color: black;
    border-radius: 10px;
}
.wpqkmlr-button{
    background-color: #de972bb5; 
    padding: 10px 24px;
}
.wpqmlr-cancel{
    background-color: #bdb5a88f; 
    padding: 10px 24px;
}
.wpqkmlr-m0{
  margin:0px;
}
.wpqkmlr-main {
    margin-bottom: 20px;
    background-color: #fff;
    border: 1px solid transparent;
    border-radius: 4px;
    -webkit-box-shadow: 0 1px 1px rgba(0,0,0,.05);
    box-shadow: 0 1px 1px rgba(0,0,0,.05);
}
.wpqkmlr-primary {
    border-color: #ddd;
}
.wpqkmlr-primary>.wpqmlrheading {
    color: #333;
    background-color: #f5f5f5;
    border-color: #ddd;
}
.wpqmlrheading {
    padding: 10px 15px;
    border-bottom: 1px solid transparent;
    border-top-left-radius: 3px;
    border-top-right-radius: 3px;
}

.wpqkmlr-body {
    padding: 15px;
}
    .wpqkmlr-form
{
    max-width: 330px;
    padding: 15px;
    margin: 0 auto;
}

.wpqkmlr-wall
{
    margin-top: -19px;
    padding: 5px 0px 20px 0px;
    background-color: white;

}
.wpqkmlr-m0{
    margin:0px;
}
.wpqkmlr-main {    
    border-radius: 2px;   
}
.wpqmlrheading {
    padding: 10px 15px;
    border-bottom: 1px solid transparent;
    border-top-left-radius: 0px;
    border-top-right-radius: 0px;
}
.wpqkmlr-primary {
    border-color: #525863;
}
.wpqkmlr-primary>.wpqmlrheading {
    color: #fff;
     background: linear-gradient(#525863, #444a55);
    border-color: #525863;
}
</style>";
return $body.$style;

	   }
	   
function wqmlUnsubscribeMls()
{//Unsubscribe Mail function
	global $wpdb;
	if(isset($_GET['qmlrunscampaignotp']))
	{
		$campaign=$_GET['qmlrunscampaignotp'];
		$email=base64_decode($_GET['card']);
		$attempt=$_GET['camp_card'];
		$campaign=substr($campaign,5,strlen($campaign));
		$attempt=substr($attempt,5,strlen($attempt));

		$existscampaign=$wpdb->get_row($wpdb->prepare("select `id`,`title` from `".$wpdb->prefix."qmlr_campaign_table` where `id`=%d and `id` not in(select `campaign` from `".$wpdb->prefix."qmlr_camp_uns_emails` where `campaign`=%s and email=%s)",array($campaign,$campaign,$email)));

		if($existscampaign)
		{
			$getlist=$wpdb->query($wpdb->prepare("select `listid` from `".$wpdb->prefix."quick_mail_mailsending_report` where `attempt`=%s and `campaign`=%s",array($attempt,$campaign)));
			$listid="0@";
			if($getlist)
			{
				$listid=$getlist->listid;
			}
			if(isset($_POST['wpqmlr-unsubs']))
			{
			$wpdb->query($wpdb->prepare("insert into `".$wpdb->prefix."qmlr_camp_uns_emails` (`id`, `campaign`, `attempt`, `email`, `list_id`, `date`) values (%d,%s,%s,%s,%s,%s)",array('',$campaign,$attempt,$email,$listid,date('d-M-Y h:ia'))));
			return 1;
			}
			return $existscampaign->title;
		}
		else
		{
			return 1;
		}
	}
	elseif(isset($_GET['qmlrunsubotp']))
	{
		$attempt=$_GET['qmlrunsubotp'];
		$email=$_GET['card'];
		$date=date('d-M-Y');
		$time=date('h:ia');
        
		$orgattmpt=substr($attempt,5,strlen($attempt));
		
		//echo "<script>alert('".$orgattmpt."');</script>";
	
		$orgemail=base64_decode($email);
	//echo "<script>alert('okkk');</script>";

	$table=$wpdb->prefix.'quick_mailer_unsubscribe_users';
	
	$mailsendingtable=$wpdb->prefix.'quick_mail_mailsending_report';
	
	$orglistid=$wpdb->get_row($wpdb->prepare("select listid from ".$mailsendingtable." where attempt=%s and email=%s",array($orgattmpt,$orgemail)));
	
	$orglistid=$orglistid->listid;
	
	$selqry="select id from ".$table." where attempt=%d and email=%s";
	$selarr=array($orgattmpt,$orgemail);
	$selres=$wpdb->query($wpdb->prepare($selqry,$selarr));
	//echo "<script>alert('".$selres."');</script>";

	if ($selres != 1) {
		
		if(isset($_POST['wpqmlr-unsubs']))
		{
		$insertdata="insert into ".$table." (id,attempt,listid,email,status,date,time) values (%d,%s,%s,%s,%s,%s,%s)";
		$insertarr=array('',$orgattmpt,$orglistid,$orgemail,1,$date,$time);
		$insrtres=$wpdb->query($wpdb->prepare($insertdata,$insertarr));
		
		$listat=rtrim(implode(',',explode('@',$orglistid)),',');
		
		$deldata=$wpdb->query($wpdb->prepare("delete from ".$wpdb->prefix.'quick_mail_email_lists'." where email=%s and listid in(".$listat.")",array($orgemail)));
		
		return 1;
		}
		else
		{
			$listtable=$wpdb->prefix.'wquick_mail_list_records';
			
			$listat=rtrim(implode(',',explode('@',$orglistid)),',');
			
			$listtablequery=$wpdb->get_results("select title from ".$listtable." where id in(".$listat.")");
			
			$arr=array();
			foreach($listtablequery as $data){$arr=array_merge($arr,array($data->title));}
			
			return implode(',',$arr);
			
		}

	}
	else
	{
		return 1;
	}
	
   
	/*$getlistid=explode("@", $orglistid);
                    $nwlistid=$getlistid[1];
                    //echo $nwlistid;  
                    $table=$wpdb->prefix.'wquick_mail_list_records';
                $sql="select title from ".$table." where id=%d";
                $arr=array($nwlistid);
                $sqlres=$wpdb->get_row($wpdb->prepare($sql,$arr));
                $title=$sqlres->title;
                // echo "<script>alert('".$title."');</script>";

	$url=plugins_url().'/WP-QuickMailer/wpquickmailer/unsubscribe.php?attempt='.$attempt.'&listid='.$title.'&email='.$email;

    echo "<script type='text/javascript'>window.location='".$url."';</script>";*/
	}
}	   

function filterContentForRedirectionPage()	   
{
	//redirection page filters
	add_action('the_content',array($this,'createRedirectionPageContent'));
	
	add_action('the_title',array($this,'createRedirectionPageTitle'));
}
function createRedirectionPageContent($content)	   
{
	if(get_the_id()==get_option($this->pref.'redirection_page_id'))
	{
	require_once('function.php');
	$ob=new wpQMailerMailSending();
	$data=$ob->filterRedirectionPageContent(1);
	if($data===0)
	{
		$data="<script>window.location='".site_url()."';</script>";
	}
	
	return $data;
	}
	else
	{
	return $content;
    }
}
function createRedirectionPageTitle($title)
{
	if(get_the_id()==get_option($this->pref.'redirection_page_id'))
	{
	require_once('function.php');
	$ob=new wpQMailerMailSending();
	$data=$ob->filterRedirectionPageContent(0);
	if($data===0)
	{
		return $title;
	}
	return $data;
	}
	else
	{
		return $title;
	}
}

function createRedirectionPage()
{
	 $my_post = array(
      'post_title'    =>wp_strip_all_tags( 'Redirect'),
      'post_content'  => '',
      'post_status'   => 'publish',
      'post_author'   =>  get_current_user_id(),
      'post_type'     => 'page',
       );
	   
	   $post_id=get_option($this->pref.'redirection_page_id');
	   
	   if($post_id)
	   {
		  if(!get_permalink($post_id))
		  {
			$postid=wp_insert_post($my_post);
			update_option($this->pref.'redirection_page_id',$postid);
		  }
	   }
	   else
	   {
		   $postid=wp_insert_post($my_post);
		   add_option($this->pref.'redirection_page_id',$postid);
	   }
}

function callBackScheduleURlChangeNotice()
{
	add_action('admin_notices',array($this,'notificationAboutScheduleUrl'));
}

function notificationAboutScheduleUrl()
{
	$savedurl=get_option($this->pref.'schedule_api_url');
	$currenturl=plugins_url('schedule_api.php',__FILE__);
	
	if(!get_option('qmlr_version_22_notif'))
	{
		if(isset($_POST['qmlrtwentytwonotif']))
		{
			add_option('qmlr_version_22_notif','1');
		}
		else
		{
		echo '<div class="notice notice-error is-dismissible"><p><strong>Hi, the URLs you added for cross origin requests in <a href="admin.php?page=wp_qmlr_delay">MailEngine setting</a> those are deleted in this version. Please update those in this version again if you have. From next version it will be updated automatically. <form action="" method="post"><input type="submit" name="qmlrtwentytwonotif" value="Got It"></form></strong></p></div>';
		}
	}
	
	if(!get_option('qmlr_version_27_notif'))
	{
		if(isset($_POST['qmlrtwentysevennotif']))
		{
			add_option('qmlr_version_27_notif','1');
		}
		else
		{
		echo '<div class="notice notice-error is-dismissible"><p><strong>Hi, we have changed your List API key for this update only, please take a look at <a href="admin.php?page=wp_qmlr_delay#listapiguide">MailEngine setting</a>. If you are using List API anywhere please use updated API key or create new one to use.<form action="" method="post"><input type="submit" name="qmlrtwentysevennotif" value="Got It"></form></strong></p></div>';
		}
	}
	
	if($savedurl !==$currenturl)
	{
		echo '	
		<script>
		function copyChangedURLOfMailEngine(str)
		{
			var elem=document.createElement("textarea");
			elem.innerText=str;
			document.body.appendChild(elem);
			elem.select();
			document.execCommand("copy");
			document.body.removeChild(elem);
		}
		</script>
		<div class="notice notice-error is-dismissible"><p><strong>The Scheduler/Sequence API URL for MailEngine changed during last update, please update the URL to your task scheduler. (<a href="admin.php?page=wp_qmlr_delay">Click to update settings </a> and <span style="cursor:pointer;" onclick=\'copyChangedURLOfMailEngine("'.$currenturl.'")\'>Copy Updated URL</span>)</strong></p></div>';
	}
}  
	   
	}
}

?>