<?php
class wpquickmailerpluginlisence
{
	protected $plugin;
	protected $prefix;
	protected $activation;
	protected $lisence;
	protected $licensedata;
	function __construct($arr)
	{ //[0]for plugin name [1] for prefix
		$this->plugin = $arr[0];
		$this->prefix = $arr[1];
	}
	function getInfo()
	{
		return array($this->plugin, $this->prefix);
	}
	function validate()
	{
		if (get_option($this->prefix . 'licensed') == '1') {
			return 1;
		} else {
			return 0;
		}
	}
	function userData()
	{
		$ip = $_SERVER['SERVER_ADDR'];
		$url = $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
		$arr = array('ip' => $ip, 'url' => $url);
		return $arr;
	}

	function post_to_our_api_url($url, $data)
	{
		$fields = '';
		$this->licensedata = json_encode($data);
		foreach ($data as $key => $value) {
			$fields .= $key . '=' . $value . '&';
		}
		rtrim($fields, '&');

		$post = curl_init();

		curl_setopt($post, CURLOPT_URL, $url);
		curl_setopt($post, CURLOPT_POST, count($data));
		curl_setopt($post, CURLOPT_POSTFIELDS, $fields);
		curl_setopt($post, CURLOPT_RETURNTRANSFER, 1);

		$result = curl_exec($post);

		curl_close($post);

		return $result;
	}


	function postValidationRequest($email, $ordercode)
	{ //echo $email;

		$srvrdata = self::userData();
		$custinfo = array(
			"custemail" => $email,
			"plugincode" => $this->plugin,
			'custip' => $srvrdata['ip'],
			'custdomain' => $srvrdata['url'],
			'custorder' => $ordercode
		);

		$posturl = "https://customerapi.teknikforce.com/api/wppluginverifyordercode";

		$data = self::post_to_our_api_url($posturl, $custinfo);


		$decodedata = json_decode($data);
		//print_r($decodedata);
		if (!isset($decodedata->valid)) {
			return 2;
		}
		if ($decodedata->valid) {
			add_option($this->prefix . 'licensed', '1');
			add_option($this->prefix . 'license_auth', $this->licensedata);

			return 1;
		} else {
			return 0;
		}
	}
}

class wpquickmaileractivationpage extends  wpquickmailerpluginlisence
{
	function __construct($arr)
	{

		parent::__construct($arr);
		add_action('admin_menu', array($this, 'loadActivationPage'));
	}
	function loadActivationPage()
	{

		add_menu_page('MailEngine', 'MailEngine', 'administrator', 'wp_quick_mlr', array($this, 'ActivationPage'), '');
	}
	function ActivationPage()
	{
		$getgdprlicenseprefix = parent::getInfo();
		$gdprlicenseprefix = $getgdprlicenseprefix[1];
		$gdprlicenseacceptbtn = $gdprlicenseprefix . 'acceptBtn';
		$gdprlicenseacceptemailfield = $gdprlicenseprefix . 'acceptEmail';
		$gdprlicenseacceptordercodefield = $gdprlicenseprefix . 'ordercode';
		if (isset($_POST[$gdprlicenseacceptbtn])) {
			$thhisactivationerr = '';
			$chkverifyedstat = parent::postValidationRequest($_POST[$gdprlicenseacceptemailfield], $_POST[$gdprlicenseacceptordercodefield]);

			if ($chkverifyedstat == 1) {
				echo "<script>window.location=''</script>";
			} elseif ($chkverifyedstat == 2) {
				$thhisactivationerr = '<font color="red">Unable To Connect.</font>';
			} else {
				$thhisactivationerr = '<font color="red">Invalid Email Id or Order Code</font>';
			}
		}

		require_once("wpmobitemplate.php");
	}
}
