<?php 
global $wpdb;
$table=$wpdb->prefix.'qmlr_campaign_table';
if(isset($_POST['qmlr_edit_campaign']))
{
    if($_POST['qmlr_campaign_id']=="0")
    {
        $wpdb->query($wpdb->prepare("insert into `".$table."` (`id`,`title`,`description`,`created_on`) values (%d,%s,%s,%s)",array('',$_POST['qmlr_campaign_title'],$_POST['qmlr_campaign_description'],date('d-M-Y h:ia'))));
    }
    else
    {
        $wpdb->query($wpdb->prepare("update `".$table."` set `title`=%s,`description`=%s where `id`=%d",array($_POST['qmlr_campaign_title'],$_POST['qmlr_campaign_description'],$_POST['qmlr_campaign_id'])));
    }
}


if(isset($_POST['qmlrcampaigndel'])) {
  $wpdb->query($wpdb->prepare("delete from ".$table." where id=%d",array($_POST['qmlrcampaigndel'])));
}
?>
<script type="text/javascript">
  var qmlrsetpost=0;
function showHideSmtpTestPopup(show,id,title="",description="")
{
    var doc=document.getElementById("wqcqmpeditdiv");
  if(show==1)
  {
    doc.style.display="block";
    var inputs=doc.getElementsByTagName("input");
    var des=doc.getElementsByTagName("textarea")[0];
    var header=doc.querySelectorAll("#campaignheader")[0];
    var submitbutton=doc.getElementsByTagName("button")[0];
    inputs[0].value=0;inputs[1].value="";des.value="";

    header.innerHTML="Add Campaign";
    submitbutton.innerHTML="Add Campaign";
    if(id>0)
    {
        inputs[0].value=id;
        header.innerHTML="Edit Campaign";
        submitbutton.innerHTML="Save";
    }
    if(title.length>0)
    {
        inputs[1].value=atob(title);
    }
    if(description.length>0)
    {
        des.value=atob(description);
    }
  }
  else
  {
    doc.style.display="none";
  }
}
</script>

  <div class="container-fluid">
  <div class="row">
  <div class="col-sm-12">
  
  <br>
        <ul class="nav nav-tabs">
  <li class="active quickmlr-menu-tabs"><a href="admin.php?page=wp_quick_mlr"><img  src="<?php echo plugins_url('image/dashboardsel.png',__FILE__); ?>"> Dashboard</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wqmlr_manage_smtp"><img  src="<?php echo plugins_url('image/frommails.png',__FILE__); ?>"> SMTPs</a></li>
    <li class="quickmlr-menu-tabs"><a href="admin.php?page=wqmlr_generated_links"><img  src="<?php echo plugins_url('image/links.png',__FILE__); ?>"> Links</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wqmlr_email_settings"><img  src="<?php echo plugins_url('image/frommails.png',__FILE__); ?>"> From Emails</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_lists"><img  src="<?php echo plugins_url('image/list.png',__FILE__); ?>"> Lists</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_compose_email"><img style="width: 24px;margin-bottom: 2px;" src="<?php echo plugins_url('image/composemails.png',__FILE__); ?>"> Compose Mail</a></li>
   <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_mails_sent"><img  src="<?php echo plugins_url('image/mailssent.png',__FILE__); ?>"> Mails Sent</a></li>  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_schedule_records"><img  src="<?php echo plugins_url('image/scheduledmails.png',__FILE__); ?>"> Scheduled Mails</a></li>
   <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_subscription_forms"><img  src="<?php echo plugins_url('image/subscriptionforms.png',__FILE__); ?>"> Subscription Forms</a></li>
   
</ul>
    
    <br/>
  <div class="panel panel-primary wqsettingpanel">
    <div class="panel-heading">
      <h4 class="m0"> Campaigns</h4></div>
    
    <div class="panel-body" style="position:relative;">

    <div class="alert alert-warning"><strong>Create, Edit, Manage Campaigns</strong></div>
    

    <div class="table-responsive">
      <table class="table">
    <thead>
        <tr class="wpqkmlr-mainrow">
        <th>#</th>
        <th>Title</th>
        <th>Sent&nbsp;Mails</th>	
        <th>Opened</th>	
        <th>Unopened</th>
        <th>Clicked</th>
        <th>Unsubscribed</th>
        <th>Opted&nbsp;Out</th>
        <th>Bounced</th>
        <th>Created&nbsp;On</th>
        <th>Action</th>
        </tr>
    </thead>
     <tbody>
      <?php
        if(isset($_GET['pagecount']))
        {
            $records=$wpdb->get_results("select * from ".$table." where id<".$_GET['pagecount']." order by id desc limit 10"); 
        }
        else
        {
            $records=$wpdb->get_results("select * from ".$table." order by id desc limit 10");
        }

        //print_r($records);

   $datacount=0;
   $lastid=0;
   
   if(isset($_GET['hashcount']))
   {
    $hashcount=$_GET['hashcount'];
   }
   else
   {
     $hashcount=0;
   }
   
   foreach($records as $data)
   {
   $hashcount++;  
     $datacount++;
     $id=$data->id;
     $title=$data->title;
     $description=$data->description;
     $created_on=$data->created_on;

     //------------------------------------
     $report_table=$wpdb->prefix.'quick_mail_mailsending_report';

     $sendstat=$wpdb->get_var($wpdb->prepare("select count(id) from ".$report_table." where campaign=%s and status in(1,2,5)",array($id)));
	
     $seenstat=$wpdb->get_var($wpdb->prepare("select count(id) from ".$report_table." where status=%s and campaign=%s",array('2',$id)));
 
     $unabletosend=$wpdb->get_var($wpdb->prepare("select count(id) from ".$report_table." where status=%s and campaign=%s",array('0',$id)));
 
     $bounces=$wpdb->get_var($wpdb->prepare("select count(id) from ".$report_table." where status=%s and campaign=%s",array('5',$id)));

     $totalunscamp=$wpdb->get_var($wpdb->prepare("select count(`id`) as `countid` from `".$wpdb->prefix."qmlr_camp_uns_emails` where `campaign`=%s",array($id)));

     $clicks=$wpdb->get_var($wpdb->prepare("select sum(visits) from ".$wpdb->prefix."quick_mailer_links_visits where emailattempt in (select attempt from ".$report_table." where campaign=%s)",array($id)));
	
     $totallinks=$wpdb->get_var($wpdb->prepare("select count(id) from ".$wpdb->prefix."quick_mailer_links_visits where emailattempt in (select attempt from ".$report_table." where campaign=%s)",array($id)));

     $unabletosend=$wpdb->get_var($wpdb->prepare("select count(id) from ".$report_table." where status=%s and campaign=%s",array('0',$id)));

     $unabletosendstat="";
     $unabletosendtext="";
     if(is_numeric($unabletosend) && $unabletosend>0)
	{
        $unabletosendstat="style='background-color:#ffe6f9' title='".number_format($unabletosend)."  Mail(s) Unable To Send'";
        $unabletosendtext="(<a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=pending&qmlr_campaign=".$id."'>View Unsent</a>)";
	}
     
     if(strlen($clicks)<1){$clicks=0;}

     $unseen=0;

     $unsubscribecnt=$wpdb->get_var($wpdb->prepare("select count(id) from ".$wpdb->prefix."quick_mailer_unsubscribe_users where attempt in (select attempt from ".$report_table." where campaign=%s)",array($id)));

     if($sendstat>0)
     {
     if($totallinks<1){$totallinksrate=1;}else{$totallinksrate=$totallinks;}	
     $clickrate=(($clicks/$sendstat)*100)/$totallinksrate;$seenrate=($seenstat/$sendstat)*100;
     //if($clickrate>100){$clickrate=100;}
     $bouncerate=($bounces/$sendstat)*100;
     $unseen=$sendstat-$seenstat;
     $unseenrate=($unseen/$sendstat)*100;
     $unsubscriberate=number_format(($unsubscribecnt/$sendstat)*100);
     $optedoutrate=number_format(($totalunscamp/$sendstat)*100);
     }
     else
     {
     $clickrate=0;$seenrate=0;$unseenrate=0;$bouncerate=0;$optedoutrate=0;$unsubscriberate=0;
     }

   
     //if(strlen($unsubscribecnt)<1){$unsubscribecnt=0;}
     
     //------------------------------------
    
     $action='<table><tr>
     <td><a href="admin.php?page=wp_quickmlr_mail_history&qmlr_campaign='.$id.'"><button class="btn btn-info" data-toggle="tooltip" title="View Detail" style="margin-right:4px;"><span class="glyphicon glyphicon-eye-open"></span></button></a></td>
     <td><button class="btn btn-primary" data-toggle="tooltip" title="Edit" onclick=showHideSmtpTestPopup(1,'.$id.',"'.base64_encode($data->title).'","'.base64_encode($data->description).'")><span class="glyphicon glyphicon-pencil"></span></button></td>
   <td>
      <form  method="post" action="">
      <button type="submit" name="qmlrcampaigndel" class="btn btn-danger" data-toggle="tooltip" title="Delete" value="'.$id.'" style="margin-left:4px;">
      <span class="glyphicon glyphicon-trash"></span>
            </button>
      </form>
      </td></tr></table>
      ';
     //title='".htmlentities($data->description)."'
     echo "<tr ". $unabletosendstat."><td>".$hashcount."</td><td>".$title."</td>
     <td><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=sent&qmlr_campaign=".$id."'>".number_format($sendstat)."</a> ".$unabletosendtext."</td><td><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=seen&qmlr_campaign=".$id."'>".number_format($seenstat)." (".number_format($seenrate,2)."%)</a></td><td><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=unseen&qmlr_campaign=".$id."'>".number_format($unseen)." (".number_format($unseenrate,2)."%)</a></td>   <td><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=linkvisits&qmlr_campaign=".$id."'>".number_format($clicks)." (".number_format($clickrate,2)."%)</a></td><td><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=unsubscribe&qmlr_campaign=".$id."' data-toggle='tooltip' title='From List'>".number_format($unsubscribecnt)." (".$unsubscriberate."%)</a></td><td><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=campaign_unsubscribe&qmlr_campaign=".$id."'>".number_format($totalunscamp)." (".$optedoutrate."%)</a></td><td><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=bounced&qmlr_campaign=".$id."'>".number_format($bounces)." (".number_format($bouncerate,2)."%)</a></td><td>".$created_on."</td><td>".$action."</td></tr>";

     if($datacount==10)
     {
      $lastid=$id; 
       break;
     }
   }
  ?>
  <tr>
  <td colspan=11>
  <ul class="pager">
  <?php if(isset($_GET['pagecount'])){
     echo '<script type="text/javascript">
            function goBack() {
              window.history.back();
                  }
                </script>';
  
  ?>
  <li class="previous" onclick="goBack()" style="cursor:pointer"><a><img src="<?php echo plugins_url( "image/previous.png",__FILE__) ?>"></a></li>
  <?php } ?>
  <?php if($datacount==10){ ?>
  <li class="next" style="cursor:pointer"><a href="<?php echo add_query_arg(array('pagecount'=>$lastid,'hashcount'=>$hashcount),$_SERVER['REQUEST_URI']); ?>"><img src="<?php echo plugins_url( "image/next.png",__FILE__) ?>"></a></li>
  <?php } ?>
  </ul>
  </td>
    </tr>
    </tbody>
  </table>  
  </div>
  
  <button type="button" class="btn btn-primary pull-right" onclick="showHideSmtpTestPopup(1,0)"><i class="glyphicon glyphicon-pencil"></i> Create Campgain</button>
  

  

   
  <div class="row">
    <div id="wqcqmpeditdiv" class="col-sm-6 col-sm-offset-3 wqtestsmtp" style="position:relative;top:30%; position:absolute;display:none;z-index:10">
    <div class="panel panel-primary">
    
    <div class="panel-heading" style="position:relative"><h4 style="margin:0px" id="campaignheader">Create Campgain</h4>
    <span class="glyphicon glyphicon glyphicon-remove-circle" style="right:2px;top:4px;position:absolute;font-size:20px;cursor:pointer" onclick="showHideSmtpTestPopup(0,0)"></span>
    </div>
    <div class="panel-body">
      <form action="" method="post">
    <div class="form-group">
    <input type="hidden" name="qmlr_campaign_id" value=0>
    <input type="text" id="qmlrtitle" class="form-control" placeholder="Enter Title" name="qmlr_campaign_title" value=""><br>
    <textarea class="form-control" placeholder="Enter Description" id="qmldescription" name="qmlr_campaign_description"></textarea>
    <div id="campgainaddstat"></div>
      <button class="btn btn-success pull-right" id="qmlraddcamp" name="qmlr_edit_campaign"style="margin-top:5px;">Add Campgain</button>
    </div></form>
    </div>
    </div>
    </div>
       </div>
    
</div>
</div>
</div>
</div>
</div>  <style>
      td {
    font-size: 15px;
}

  </style>