<?php

require_once('function.php');
require_once('emailsettngfunc.php');
require_once('listfunc.php');

global $wpdb;
$table=$wpdb->prefix.'quick_mail_mailsending_report';
$smtpobj=new wpQMailerMailSending();

if(isset($_POST['qmlr_del_sendings']))
{
   $report_table= $wpdb->prefix.'quick_mail_mailsending_report';
   $links_visit_table= $wpdb->prefix.'quick_mailer_links_visits';
   $unsubscribe_table= $wpdb->prefix."quick_mailer_unsubscribe_users";

   $wpdb->query($wpdb->prepare("delete from `".$report_table."` where `attempt`=%s", array($_POST['qmlr_del_sendings'])));

   $wpdb->query($wpdb->prepare("delete from `".$links_visit_table."` where `emailattempt`=%s", array($_POST['qmlr_del_sendings'])));

   $wpdb->query($wpdb->prepare("delete from `".$unsubscribe_table."` where `attempt`=%s", array($_POST['qmlr_del_sendings'])));

}


if(isset($_POST['wqdelallsentmails']))
{
$wqdelallsentmailsqry="delete from ".$table." where status in ('1','2')";
$wpdb->query($wqdelallsentmailsqry);
$wpdb->query("delete from ".$wpdb->prefix."quick_mailer_links_visits");	
}
if(isset($_GET['pagecount']))
{
	$getattempts=$wpdb->get_results($wpdb->prepare("select distinct(attempt),sentdata from ".$table." where attempt<%d and status in ('1','2') order by id desc limit 25",array($_GET['pagecount'])));
}
else
{
$getattempts=$wpdb->get_results("select distinct(attempt),sentdata from ".$table." where status in ('1','2') order by id desc limit 25");
}
//print_r((array)$getattempts);
?>

<html>
<head></head>
<body>
<div class="container-fluid">
<div class="col-sm-12">
<br>
<ul class="nav nav-tabs">
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quick_mlr"><img  src="<?php echo plugins_url('image/dashboard.png',__FILE__); ?>"> Dashboard</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wqmlr_manage_smtp"><img  src="<?php echo plugins_url('image/frommails.png',__FILE__); ?>"> SMTPs</a></li>
    <li class="quickmlr-menu-tabs"><a href="admin.php?page=wqmlr_generated_links"><img  src="<?php echo plugins_url('image/links.png',__FILE__); ?>"> Links</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wqmlr_email_settings"><img  src="<?php echo plugins_url('image/frommails.png',__FILE__); ?>"> From Emails</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_lists"><img  src="<?php echo plugins_url('image/list.png',__FILE__); ?>"> Lists</a></li>
  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_compose_email"><img src="<?php echo plugins_url('image/composemails.png',__FILE__); ?>"> Compose Mail</a></li>
   <li class="active quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_mails_sent"><img  src="<?php echo plugins_url('image/mailssentsel.png',__FILE__); ?>"> Mails Sent</a></li>  <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_schedule_records"><img  src="<?php echo plugins_url('image/scheduledmails.png',__FILE__); ?>"> Scheduled Mails</a></li>
   <li class="quickmlr-menu-tabs"><a href="admin.php?page=wp_quickmlr_subscription_forms"><img  src="<?php echo plugins_url('image/subscriptionforms.png',__FILE__); ?>"> Subscription Forms</a></li>
   
</ul><br>

<div class="panel panel-primary wqsettingpanel">
<div class="panel-heading"><h4 class="m0"><img src="<?php echo plugins_url('image/bic/mailssent.png', __FILE__);?>">  Mails Sent</h4></div>
<div class="panel-body">

<div class="alert alert-warning infodescri">View the emails you've sent out earlier. If you want to reuse any email, click on it to open it in the composer.</div>

<form action="" method="post">
<button type="submit" name="wqdelallsentmails" class="btn btn-danger"><span class="glyphicon glyphicon-trash"></span> Clear All Records</button>
</form>
<br>
<!--<div class="alert alert-warning">
	This section displays statistics about the mails that your server sends over a period of time.
</div>-->

<div class="table-responsive">
<table class="table table-bordered">
<thead>
<tr class="wpqkmlr-mainrow"><th>#</th><th>Date</th><th>Subject</th><th>Campaign</th><th>Total&nbsp;Emails</th><th>Opened</th><th>Unopened</th><th>Clicked</th><th>Unsubscribed</th><th>Bounced</th><th>SMTPs</th><th>Action</th></tr>
</thead>
<tbody>
<?php
if(isset($_GET['qmlrhash']))
{
	$hash=$_GET['qmlrhash'];
}
else
{
	$hash=0;
}
$count=0;
$lastid=0;
foreach($getattempts as $data)
{
	$hash++;
	$count++;
	
	/*$clicks=$wpdb->get_var("select sum(visits) from ".$wpdb->prefix."quick_mailer_links_visits where emailattempt='".$data->attempt."'");*/
	
	//sent mails,unable to send count 
	$sentcount=$wpdb->get_var("select count(id) from ".$table." where attempt='".$data->attempt."' and status in (1,2,5)");
	
	$unablecount=$wpdb->get_var("select count(id) from ".$table." where attempt='".$data->attempt."' and status=0");
	
	if($unablecount>0)
	{
		$unablstat="";
	}
	else
	{}
    //----Date Time----
	
	$datetime=$wpdb->get_row($wpdb->prepare("select date,time from ".$table." where attempt=%s order by id desc limit 1",array($data->attempt)));
	
	$datetime=$datetime->date.' '.$datetime->time;
	
	//----seen status and click status----
	$seenstat=$wpdb->get_var("select count(id) from ".$table." where attempt='".$data->attempt."' and status='2'");

	$bounced=$wpdb->get_var("select count(id) from ".$table." where attempt='".$data->attempt."' and status='5'");
	
	$clicks=$wpdb->get_var($wpdb->prepare("select sum(visits) from ".$wpdb->prefix."quick_mailer_links_visits where emailattempt=%s",array($data->attempt)));
	
	$totallinks=$wpdb->get_var($wpdb->prepare("select count(id) from ".$wpdb->prefix."quick_mailer_links_visits where emailattempt=%s",array($data->attempt)));
	
	if(strlen($clicks)<1){$clicks=0;}
	
	$campaign_title="N/A";
	
	$campaign_query=$wpdb->get_row($wpdb->prepare("select `id`,`title` from `".$wpdb->prefix."qmlr_campaign_table` where `id` in (select `campaign` from `".$table."` where `attempt`=%s)",array($data->attempt)));
	
	$total_uns_from_camp="";
	if($campaign_query)
		{
			//admin.php?page=wp_quickmlr_mail_history
			$campaign_title="<a href='admin.php?page=wp_quickmlr_mail_history&qmlr_campaign=".$campaign_query->id."'>".$campaign_query->title."</a>";

			$totalunscamp=$wpdb->get_var($wpdb->prepare("select count(`id`) as `countid` from `".$wpdb->prefix."qmlr_camp_uns_emails` where `attempt`=%s and `campaign`=%s",array($data->attempt,$campaign_query->id)));

			if($totalunscamp>0)
			{
			$total_uns_from_camp="(<a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=campaign_unsubscribe&wqmlrattempt=".$data->attempt."'>".number_format($totalunscamp)." From Campaign</a>)";
			}
		}

        //----unsubscribe stat-----
		$unsubscribecnt=$wpdb->get_var($wpdb->prepare("select count(id) from ".$wpdb->prefix."quick_mailer_unsubscribe_users where attempt=%s",array($data->attempt)));
		if(strlen($unsubscribecnt)<1){$unsubscribecnt=0;}

	$unseen=0;
	if($sentcount>0)
	{
	if($totallinks<1){$totallinksrate=1;}else{$totallinksrate=$totallinks;}	
	$clickrate=(($clicks/$sentcount)*100)/$totallinksrate;$seenrate=($seenstat/$sentcount)*100;
	$bouncerate=($bounced/$sentcount)*100;
	//if($clickrate>100){$clickrate=100;}
	$unseen=$sentcount-$seenstat;
	$unseenrate=($unseen/$sentcount)*100;

	$unsubscriberate=number_format(($unsubscribecnt/$sentcount)*100);
     $optedoutrate=number_format(($totalunscamp/$sentcount)*100);
	}
	else
	{
	$clickrate=0;$seenrate=0;$unseenrate=0;$bouncerate=0;$unsubscriberate=0;  $optedoutrate=0;
	}
	

	
	//--------Subject and SMTP-----------
	
	$subject=explode('@wqmlbrk@',$data->sentdata);
	
	$allsmtpusedid=$wpdb->get_results($wpdb->prepare("select distinct(smtpid) from ".$table." where attempt=%s and status in(1,2)",array($data->attempt)));
	
	$smtpused="";
	
	foreach($allsmtpusedid as $allsmtpusediddata)
	{
	if($allsmtpusediddata->smtpid !='wpmail')
	{
	$smtpdetail=$smtpobj->getSmtpSettings($allsmtpusediddata->smtpid);
	$smtpused .="<a href='admin.php?page=wqmlr_smtp_create_new&smtpid=".$smtpdetail->id."'>#".$smtpdetail->id." ".$smtpdetail->title."</a>, ";
	
	}
    else
	{
		$smtpused .='WordPress Mailer, ';
	}
	}
	$smtpused=trim($smtpused,', ');
	
	$live_url= add_query_arg(array('qmlr_type'=>'attempt', 'qmlr_id'=>$data->attempt), 'admin.php?page=wqmlr_live_sending_stat');

	$action_btns= "<table><tr><td><a href='".$live_url."'><button class='btn btn-primary' data-toggle='tooltip' title='View Live sending' style='margin-right: 4px;'><span class='glyphicon glyphicon-eye-open'></span></button></a></td><td><form action='' method='POST' onsubmit='return confirm(`Are you sure about deleting?`)'>
	<input type='hidden' name='qmlr_del_sendings' value='".$data->attempt."'>
	<button type='submit' class='btn btn-danger'><span class='glyphicon glyphicon-trash'></span></button></form></td></tr></table>";

	
	echo "<tr><td>".$hash."</td> <td>".$datetime."</td> <td><a href='admin.php?page=wp_compose_email&qmlrgetbyattempt=".$data->attempt."'>".$subject[0]."</a></td><td>".$campaign_title."</td><td class='wpqkmlr-num'><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=sent&wqmlrattempt=".$data->attempt."'>".number_format($sentcount)."</a></td> <td class='wpqkmlr-num'><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=seen&wqmlrattempt=".$data->attempt."'>".number_format($seenstat)." (".number_format($seenrate,2)."%)</a></td><td class='wpqkmlr-num'><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=unseen&wqmlrattempt=".$data->attempt."'>".number_format($unseen)." (".number_format($unseenrate)."%)</a></td><td class='wpqkmlr-num'><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=linkvisits&wqmlrattempt=".$data->attempt."'>".number_format($clicks)." (".number_format($clickrate,2)."%)</a></td><td><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=unsubscribe&wqmlrattempt=".$data->attempt."' data-toggle='tooltip' title='From List'>".number_format($unsubscribecnt)."</a> ".$total_uns_from_camp."</td><td><a href='admin.php?page=wp_quickmlr_sent_emails_details&wqquery=bounced&wqmlrattempt=".$data->attempt."'>".number_format($bounced)." (".number_format($bouncerate)."%)</a></td><td>".$smtpused."</td><td>".$action_btns."</td></tr>";
	
	$pagecount=$data->attempt;
}
$pagerneeded=0;
$prevlink="";
$nextlink="";
if(isset($_GET['pagecount']))
	{$pagerneeded++;
    $prevlink='<script type="text/javascript">
            function wqGoBack() {
              window.history.back();
                  }</script>
      <li class="previous" style="cursor:pointer"><a onclick="wqGoBack()"><img src="'.plugins_url( "image/previous.png",__FILE__).'"></a></li>';
	}

if($count==25)
{
	$pagerneeded++;
	 $nextlink='<li class="next"><a href="'.add_query_arg( array('pagecount'=>$pagecount,'qmlrhash'=>$hash),$_SERVER['REQUEST_URI'] ).'" class="wpqmlr-nxt"><img src="'.plugins_url( "image/next.png",__FILE__).'"></a></li>';
}

if($pagerneeded !=0)
{
	echo "<tr><td colspan='11'><ul class='pager'>".$prevlink.$nextlink."</ul></td></tr>";
}
?>
</tbody>
</table>
</div>

</div>
</div>




</div>
</div>
<style type="text/css">
td,th{
	text-align: left !important; 
}
.wpqkmlr-num{
	/*text-align: right !important;*/
}


.table-striped>tbody>tr:nth-child(even):hover{
 	background-color: #eae7ea;
 }

 .wpqkmlr-mainrow{
 	background-color: #d2cccc;
 }
 .nav-tabs>li>a>img {
    max-width: 20px !important;
}

</style>
</body>
</html>