<?php 
class wpQuickSaveList
{
	function __construct()
	{
		
	}
	function load_prioritize_settings()
	{
		self::save_prioritize_settings();
		require_once("prioritize_settings.php");
	}
	function save_prioritize_settings()
	{
		if(isset($_POST['wqmlr_add_priority']))
		{
			global $wpdb;
			$lists= json_decode( base64_decode($_POST['wqmlr_add_priority']));
			$table= $wpdb->prefix.'wquick_mail_list_records';
			foreach($lists as $list=>$priority)
			{
				$wpdb->query($wpdb->prepare("update `".$table."` set `priority`=%d where `id`=%d", array($priority, $list)));
			}
		}
	}
	function load_list_settings()
	{
		self::save_list_settings();
		require_once('list.php');

	}
	function save_list_settings()
	{
		global $wpdb;
		$table_name=$wpdb->prefix . 'quick_mail_email_lists';
		//echo $table_name;
		if(isset($_POST['wpqmlrfirstlistnamesave']))
		{
			$listname=$_POST['wpqmlr-list-name'];
			$table=$wpdb->prefix.'wquick_mail_list_records';
			$date=date('d-M-Y h:ia');
			$insert_arr=array('',$listname,$date);
			//print_r($insert_arr);
			$sql1="insert into ".$table." (id,title,creationdate) values (%d,%s,%s)";

			$insert_result=$wpdb->query($wpdb->prepare($sql1,$insert_arr));
			
			
			$gettheid="select id from ".$table." order by id desc";
				$getrow=$wpdb->get_row($gettheid);
				$current_user_id=$getrow->id;
			echo "<script>window.location='admin.php?page=wp_quickmlr_create_lists&wqlistid=".$current_user_id."';</script>";
			
			
			
			
		}
		elseif(isset($_POST['wpqmlrcsvfilesave'])) {
			
			$datajsn=stripcslashes($_POST['storefromcsv']);
			
			$dataarr=array();
			
			if(strlen($datajsn)>0)
			{
				$dataarr=json_decode($datajsn);
			}
			
				if (is_array($dataarr)) {
			$csveml="";
			
			$incount=0;
			
				   $listid=$_POST['wqlistid'];
				   $listtitle=$_POST['wpqmlr_list_name_csv'];
				   
				   $listmailsarr=json_decode($_POST['storefromcsv']);
			
			$listtablethis=$wpdb->prefix.'wquick_mail_list_records';
			if(!isset($_POST['from_verification_screen']))
			{
				$wpdb->query($wpdb->prepare("update ".$listtablethis." set title=%s where id=%d",array($listtitle,$listid)));
			}
			
			for($i=0;$i<count($dataarr);$i++) {
	      	//echo $emails;
	      	if (filter_var($dataarr[$i][1], FILTER_VALIDATE_EMAIL))
			      {  
				   ++$incount;
				  $name=$dataarr[$i][0];
				  
				  $email=$dataarr[$i][1];
				  
				  if(isset($_POST['from_verification_screen']))
				  {
					$extrafield= $dataarr[$i][2];
				  }
				  else
				  {
					$extrafield=base64_encode($dataarr[$i][2]);
				  	$extrafield .='@admin@';
				  }
				 
				  $datethis=date('d-M-Y h:ia');
				  
				  $checkavlblity=$wpdb->get_row($wpdb->prepare("select email from ".$table_name." where listid=%d and email=%s",array($listid,$email)));
				  //echo "<script>alert('".$checkavlblity."');</script>";
				 // $testalreadyadded=
				  if(!$checkavlblity)
				     {
						 
						 
						 $ipaddress = '';
    if (isset($_SERVER['HTTP_CLIENT_IP']))
        $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
    else if(isset($_SERVER['HTTP_X_FORWARDED_FOR']))
        $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
    else if(isset($_SERVER['HTTP_X_FORWARDED']))
        $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
    else if(isset($_SERVER['HTTP_FORWARDED_FOR']))
        $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
    else if(isset($_SERVER['HTTP_FORWARDED']))
        $ipaddress = $_SERVER['HTTP_FORWARDED'];
    else if(isset($_SERVER['REMOTE_ADDR']))
        $ipaddress = $_SERVER['REMOTE_ADDR'];
    else
        $ipaddress = 'UNKNOWN';						 						 						 
	 $in=$wpdb->query($wpdb->prepare("insert into ".$table_name." (id,listid,name,email,exf,ipadr,date) values (%d,%s,%s,%s,%s,%s,%s)",array('',$listid,$name,$email,$extrafield,$ipaddress,$datethis)));
				     }

				  } 
				}
				if($incount==0)
				{
					return 0;
				}
				else
				{
					return 1;
				}
				
			}
		
		}
		

	}
	function arrangeListsBasedOnPriority($lists= array())
	{
		global $wpdb;
		$lists= array_filter($lists, function($list){ if(is_numeric($list) && $list>0){return true;}else{return false;} });
		if(count($lists)>0)
		{
			$table= $wpdb->prefix.'wquick_mail_list_records';
			$all= $wpdb->get_results("select `id` from `".$table."` where `id` in (".implode(',', $lists).") order by `priority` desc");
			$arr= array();
			foreach($all as $list)
			{
				array_push($arr, $list->id);
			}
			return $arr;
		}
		else
		{
			return $lists;
		}
	}
	function get_user_id($id)
	{
		global $wpdb;
		$table=$wpdb->prefix."quick_mail_email_lists";
		$results=$wpdb->get_results($wpdb->prepare("select email from ".$table." where listid=%s",array($id)));
		$emails="";
		foreach($results as $email)
		{
			$emails .=$email->email.',';
		}
		return $emails;
	}
	function doEncDec($id,$do='enc')
	{
		$arr=array('a','b','d','c','A','@','m','n','P','Q');
		
		if($do=='dec')
		{
		$id=base64_decode(str_replace("mleng:","",$id));
		}
		
		$idarr=str_split($id);
		if($do=='enc')
		{
			for($i=0;$i<count($idarr);$i++)
			{
				$idarr[$i]=$arr[$idarr[$i]];
			}
			$id=base64_encode(implode("",$idarr));
			$id="mleng:".$id;
		}
		elseif($do=='dec')
		{
			for($i=0;$i<count($idarr);$i++)
			{
				$idarr[$i]=array_search($idarr[$i],$arr);
				if($idarr[$i]===false)
				{return 0; break;}
			}
			$id=implode("",$idarr);
		}
		return $id;
	}
	function getAllLists()
	{
		global $wpdb;
		$table=$wpdb->prefix.'wquick_mail_list_records';
		$lists=$wpdb->get_results("select `id`, `title` from `".$table."` order by `id` desc");
		return $lists;
	}
	function getAllListsByPriority()
	{
		global $wpdb;

		$table= $wpdb->prefix.'wquick_mail_list_records';
		$emails_table= $wpdb->prefix . 'quick_mail_email_lists';

		$lists=$wpdb->get_results("select `a`.id as `id`, `a`.title as `title`, (select count(*) from `".$emails_table."` where `listid`=`a`.id) as `subscribers`  from `".$table."` as `a` order by `a`.priority desc, `a`.id desc");

		return $lists;
	}
	function getLeadsBYIds($id_s){
		global $wpdb;
		$table= $wpdb->prefix . 'quick_mail_email_lists';
		$id_s= explode(',', $id_s);
		$id_arr=[];
		for($i=0; $i<count($id_s); $i++)
		{
			if(is_numeric($id_s[$i]))
			{
				array_push($id_arr, "'".$id_s[$i]."'");
			}
		}

		$data= $wpdb->get_results($wpdb->prepare("select * from `".$table."` where `listid` in (".implode(',', $id_arr).")"));
		return $data;
	}
	function rmEmailsInSelectedLists($lists, $emails){
		global $wpdb;
		$table= $wpdb->prefix . 'quick_mail_email_lists';

		$lists= explode(',', $lists);
		for($i=0; $i<count($lists); $i++)
		{
			if(is_numeric($lists[$i]))
			{
				$lists[$i]= "'".$lists[$i]."'";
			}
			else
			{
				unset($lists[$i]);
			}
		}
		$lists= implode(",", $lists);

		$emails= explode(',', $emails);
		for($i=0; $i<count($emails); $i++)
		{
			if(filter_var($emails[$i], FILTER_VALIDATE_EMAIL))
			{
				$emails[$i]= "'".$emails[$i]."'";
			}
			else
			{
				unset($emails[$i]);
			}
		}
		$emails= implode(',', $emails);
		//this query without prepare
		$del=$wpdb->query("delete from `".$table."` where `listid` in (".$lists.") and `email` in (".$emails.")");
		return (($del)? 1:0);
	}
	function createAPIList($title)
	{
		global $wpdb;
		$table= $wpdb->prefix.'wquick_mail_list_records';
		$date= date('d-M-Y h:ia');
		$wpdb->query($wpdb->prepare("insert into `".$table."` (`title`, `creationdate`) values (%s, %s)", array($title, $date)));
		return $wpdb->insert_id;
	}
	function getAllListsForAPI()
	{
		global $wpdb;
		$table=$wpdb->prefix.'wquick_mail_list_records';
		$results=$wpdb->get_results("select `id`,`title`,`creationdate` as `created_on` from `".$table."` order by `id` desc");
		$arr=array();
		foreach($results as $result)
		{
			$result->id=self::doEncDec($result->id);
			array_push($arr,$result);
		}
		return $arr;
	}
	function getAllLeadsForAPI($list, $count=10)
	{
		global $wpdb;
		$table= $wpdb->prefix . 'quick_mail_email_lists';

		$read_exf= function($exf){
			$subs_exf= $exf;
			$exf=str_replace('@subs@','',$exf);
			$exf=str_replace('@admin@','',$exf);
			$exf=str_replace('@api@','',$exf);
			$exf=base64_decode($exf);


			$exf= explode('@jsnbrk@', $exf);
			
			return $exf;
		};

		$count=(int)$count;

		$limit="";

		if($count>=0)
		{
			$limit= " limit ".$count;
		}

		$data= $wpdb->get_results($wpdb->prepare("select `name`, `email`, `exf`, `ipadr`, `date` from `".$table."` where `listid`=%s order by `id` desc".$limit, array($list)));

		$data= (array) $data;
		for($i=0; $i<count($data); $i++)
		{
			$data[$i]->exf= $read_exf($data[$i]->exf);
			$data[$i]->additional_data= $data[$i]->exf;
			unset($data[$i]->exf);
		}

		return $data;
	}
	function hasList($id)
	{
		global $wpdb;
		$table=$wpdb->prefix.'wquick_mail_list_records';
		if($wpdb->get_var($wpdb->prepare("select count(`id`) as `countid` from `".$table."` where `id`=%d",array($id))))
		{
			return 1;
		}
		else
		{
			return 0;
		}
	}
	function showAllSmtpinOptionList($smtpid)
	{
		global $wpdb;
		$table=$wpdb->prefix.'quick_mail_smtp_settings';
		$gettheid="select * from ".$table." order by id desc";
		$selected="";
		$getresult=$wpdb->get_results($gettheid);
		foreach($getresult as $data)
		{
			if($data->id==$smtpid)
			{$selected="selected";}
			echo "<option value='".$data->id."' ".$selected.">".$data->title."</option>";
			$selected="";
			
		}
		
	}
	function showAllSentFromInOptionList($fromid)
	{
		global $wpdb;
		$table=$wpdb->prefix.'quick_mlr_email_setting';
		$gettheid="select * from ".$table." order by id desc";
		$getresult=$wpdb->get_results($gettheid);
		$selected="";
		foreach($getresult as $data)
		{
			if($fromid==$data->id)
			{
			$selected="selected";	
			}
			echo "<option value='".$data->id."' ".$selected.">".$data->title."</option>";
			$selected="";
		}
		
	}
	function saveListMailer($id, $from_id, $smtp_id)
	{
		global $wpdb;
    	$listtable=$wpdb->prefix.'wquick_mail_list_records';
		$did_up= $wpdb->query($wpdb->prepare("update `".$listtable."` set `smtp`=%d, `from_address`=%d where `id`=%d", array($smtp_id, $from_id, $id)));
		return ($did_up)? true: false;
	}
}

?>