<?php 
use mikehaertl\shellcommand\Command;
class wpqkmlschdlmail
{
	public $rqurl;
	public $curlurl;
	
	public $pref;
	
function __construct()
{
	
	    $this->pref="wp_quick_mlr_";
		$this->rqurl=plugins_url('ajaxmailsend.php',__FILE__);
		
		//$this->curlurl= "http://mailengine.in/api/schedulewpqmail";
		//$this->curlurl="http://localhost:8080/test/schedular/index.php";
		$this->curlurl=get_option($this->pref."schedule_api_url");
}

function loadScheduleMailSettingPage()
{
	self::scheduleWpqMail();
	require_once("composemailfunction.php");
	include("schedulemails.php");

}

function loadSchedularRecordsPage()
{
	require_once('schedulerecords.php');
} 

function scheduleWpqMail($compose= false)
{
	global $wpdb;
	$tablename=$wpdb->prefix . 'qmlr_eml_scheedular';
	//echo $tablename;
	if(isset($_POST['wpqmlrsubmitschedule']) || $compose)
	{
        $smtpid= $_POST['wpqmlrschdlsmtp'];
		$fromid= $_POST['wpqmlrschdlsendfrom'];
        $listid= $_POST['wpqmlrschdlemailselect'];
        $campaign= $_POST['qmlrselectcampaign'];
		$newadded= $_POST['wpqmlrschdlemailmanual'];
		//$newadded=str_replace("\n",',',$newadded);
		$subject= stripcslashes($_POST['wpqmlrschdlemailsub']);
		$body= stripcslashes($_POST['wpqmlrmlbody']);
		
		
		if(isset($_POST['wqautoaddcontactdetail']))
		{
			if(strpos($body,"[wq-contact-template autoadd='1']")<=0)
			$body .="[wq-contact-template autoadd='1']";
		}
		else
		{
			$body=str_replace("[wq-contact-template autoadd='1']","",$body);
		}
		
		$spintext='0';$spinurl='0';
		if(isset($_POST['qmlrspintxt']))
		{$spintext='1';}
		if(isset($_POST['qmlrspinurls']))
		{$spinurl='1';}
		
		$emailtopost=0;
		if(isset($_POST['wqemltopost']) && isset($_POST['wqemltopage']))
		{
			$emailtopost='both';	
		}
		elseif(isset($_POST['wqemltopost']))
		{
			$emailtopost=1;
		}
		elseif(isset($_POST['wqemltopage']))
		{
			$emailtopost=2;
		}
		
		$unsmessahge=stripcslashes($_POST['wpqmlrunsubscribe']);
		
		$schdltime= $_POST['wpqmlrschdltime'];
		$schdldate= $_POST['wpqmlrschdldate'];
		$sentdata= $subject."@wqmlbrk@".$body."@wqmlbrk@".$unsmessahge;
		$date= date("d-M-Y");
		$time= date("h:ia");
		
		$otp= substr(str_shuffle('abcdefghijklmnopqrstuvwxyz01234567890'),0,5);
		$otp .= $date.$time;
		
		$timezone=$_POST['wqmlrtimezone'];

        if($compose)
        {
            $schdldate= date('Y-m-d');
            $schdltime= date('h:i A');
            $timezone= date_default_timezone_get();
        }        
		
		$rqurl=$this->rqurl;
		
		$done=0;
		
		if(isset($_GET['wqmlrscheduleid']))
		{
			$currentid=$_GET['wqmlrscheduleid'];
		   
		   $getupdateddata=self::get_scheduled_id($currentid);
		   
		   $otp=$getupdateddata->stoken;
			
		}
		
		
		$rsipp= self::getUserIPqmlr();
		$scheduleonserver= self::reqToCreatorForSchedule($this->rqurl, $otp, $timezone, $schdldate, $schdltime, $rsipp, '1');
		
		if($scheduleonserver)
		{
            if(!isset($_GET['wqmlrscheduleid']))
            {
                $done++;	
                $insertarr=array('',$listid,$smtpid,$fromid,'1',$sentdata,$newadded,$schdldate,$schdltime,$timezone,$otp,$spintext,$spinurl,$emailtopost,'','0',$campaign,$date,$time);

                $insertsql= "insert into ".$tablename."(id,listid,smtpid,fromid,status,sentdata,extraemails,sdate,stime,stimezone,stoken,spintext,spinurl,emailtopost,mailssent,attempt,`campaign`,date,time)values(%d,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s)";

                $insrtres=$wpdb->query($wpdb->prepare($insertsql,$insertarr));
                //echo $insrtres;

                $getschdlidd="select max(id) from ".$tablename." order by id desc";
                $currentid=$wpdb->get_var($getschdlidd);

                //self::execComposeInBackground($otp);

                $params_arr= array('qmlr_type'=>'schedule', 'qmlr_id'=> $currentid);

                if($compose)
                {
                    $params_arr['compose_token']= $otp;
                }

                $url= add_query_arg($params_arr, 'admin.php?page=wqmlr_live_sending_stat');

                echo "<script>window.location= `".$url."`; </script>";
                die();
            }
            else
            {
                $done++;
                $arraydata = array($listid,$smtpid,$fromid,'1',$sentdata,$newadded,$schdldate,$schdltime,$timezone,$spintext,$spinurl,$emailtopost,$campaign,$date,$time,$_GET['wqmlrscheduleid']);
        
        
                $sqlupdate="update ".$tablename." set listid=%s,smtpid=%s,fromid=%s,status=%s,sentdata=%s,extraemails=%s,sdate=%s,stime=%s,stimezone=%s,spintext=%s,spinurl=%s,emailtopost=%s,campaign=%s,date=%s,time=%s where id=%d";
            
                $wpdb->query($wpdb->prepare($sqlupdate,$arraydata));
            
            }
	  }

         if($done>0)
		 {
			 
			// echo $this->curlurl; echo $this->rqurl;
	
			echo "<script>window.location='".add_query_arg(array('wqmlrscheduleid'=>$currentid,'qmlrgetbyattempt'=>1,'wqemailscheduled'=>1),$_SERVER['REQUEST_URI'])."'</script>";
			 
		 }
        else
        {
			echo "<script>alert('Unable To Schedule This Email');</script>";
		}			
		
	}
	
 }

    function execComposeInBackground($token= false) 
    {
        if(is_string($token))
        {
            require_once("vendor/autoload.php");
            $token= "--compose_token--".$token;
            $cron_file= rtrim(str_replace('\\', '/', __DIR__), '/');
            $cron_file .='/schedule_api.php';
            $cmd= "php ".$cron_file." ".$token;

            if($_SERVER['HTTP_HOST'] !=="localhost")
            {
                $cmd.= " >/dev/null 2>&1";
            }

            $command = new Command($cmd);
            if ($command->execute()) {
                //echo $command->getOutput();
            } else {
                //echo $command->getError();
                $exitCode = $command->getExitCode();
            }
        }
    }


function reqToCreatorForSchedule($rurl,$token,$timezone,$rdate,$rtime,$rsipp,$status)
     {
		 $ch = curl_init();
         curl_setopt($ch, CURLOPT_URL,$this->curlurl);
         curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
         curl_setopt($ch, CURLOPT_POST, true);

          $data = array(
		  'auth'=>get_option($this->pref.'schedule_api_token'),
          'rburl' =>$rurl,
          'rtoken' =>$token,
          'rtimezone' =>$timezone,
		  'rdate' =>$rdate,
          'rtime' =>$rtime,
            'rpip' =>$rsipp,
			'rstatus' =>$status
              );

curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
$output = curl_exec($ch);
//echo $output;
$info = curl_getinfo($ch);
curl_close($ch);

$jsn=json_decode($output);
return $jsn->created;
	
     }
	 
function getUserIPqmlr()
{
	  $ipaddress = '';
    if (isset($_SERVER['HTTP_CLIENT_IP']))
        $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
    else if(isset($_SERVER['HTTP_X_FORWARDED_FOR']))
        $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
    else if(isset($_SERVER['HTTP_X_FORWARDED']))
        $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
    else if(isset($_SERVER['HTTP_FORWARDED_FOR']))
        $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
    else if(isset($_SERVER['HTTP_FORWARDED']))
        $ipaddress = $_SERVER['HTTP_FORWARDED'];
    else if(isset($_SERVER['REMOTE_ADDR']))
        $ipaddress = $_SERVER['REMOTE_ADDR'];
    else
        $ipaddress = 'UNKNOWN';
    return $ipaddress;
} 
	 
function get_scheduled_id($id)
	{
		global $wpdb;
		$tablepref=$wpdb->prefix;
		$table=$tablepref."qmlr_eml_scheedular";
		$id=(int)$id;
		$result=$wpdb->get_row($wpdb->prepare("select * from ".$table." where id=%d",array($id)));
		return $result;
	}

function timeZoneSelect($zone='UTC')
{
	$arr=array (
    '(UTC-11:00) Midway Island' => 'Pacific/Midway',
    '(UTC-11:00) Samoa' => 'Pacific/Samoa',
    '(UTC-10:00) Hawaii' => 'Pacific/Honolulu',
    '(UTC-09:00) Alaska' => 'US/Alaska',
    '(UTC-08:00) Pacific Time (US &amp; Canada)' => 'America/Los_Angeles',
    '(UTC-08:00) Tijuana' => 'America/Tijuana',
    '(UTC-07:00) Arizona' => 'US/Arizona',
    '(UTC-07:00) Chihuahua' => 'America/Chihuahua',
    '(UTC-07:00) La Paz' => 'America/Chihuahua',
    '(UTC-07:00) Mazatlan' => 'America/Mazatlan',
    '(UTC-07:00) Mountain Time (US &amp; Canada)' => 'US/Mountain',
    '(UTC-06:00) Central America' => 'America/Managua',
    '(UTC-06:00) Central Time (US &amp; Canada)' => 'US/Central',
    '(UTC-06:00) Guadalajara' => 'America/Mexico_City',
    '(UTC-06:00) Mexico City' => 'America/Mexico_City',
    '(UTC-06:00) Monterrey' => 'America/Monterrey',
    '(UTC-06:00) Saskatchewan' => 'Canada/Saskatchewan',
    '(UTC-05:00) Bogota' => 'America/Bogota',
    '(UTC-05:00) Eastern Time (US &amp; Canada)' => 'US/Eastern',
    '(UTC-05:00) Indiana (East)' => 'US/East-Indiana',
    '(UTC-05:00) Lima' => 'America/Lima',
    '(UTC-05:00) Quito' => 'America/Bogota',
    '(UTC-04:00) Atlantic Time (Canada)' => 'Canada/Atlantic',
    '(UTC-04:30) Caracas' => 'America/Caracas',
    '(UTC-04:00) La Paz' => 'America/La_Paz',
    '(UTC-04:00) Santiago' => 'America/Santiago',
    '(UTC-03:30) Newfoundland' => 'Canada/Newfoundland',
    '(UTC-03:00) Brasilia' => 'America/Sao_Paulo',
    '(UTC-03:00) Buenos Aires' => 'America/Argentina/Buenos_Aires',
    '(UTC-03:00) Georgetown' => 'America/Argentina/Buenos_Aires',
    '(UTC-03:00) Greenland' => 'America/Godthab',
    '(UTC-02:00) Mid-Atlantic' => 'America/Noronha',
    '(UTC-01:00) Azores' => 'Atlantic/Azores',
    '(UTC-01:00) Cape Verde Is.' => 'Atlantic/Cape_Verde',
    '(UTC+00:00) Casablanca' => 'Africa/Casablanca',
    '(UTC+00:00) Edinburgh' => 'Europe/London',
    '(UTC+00:00) Greenwich Mean Time : Dublin' => 'Etc/Greenwich',
    '(UTC+00:00) Lisbon' => 'Europe/Lisbon',
    '(UTC+00:00) London' => 'Europe/London',
    '(UTC+00:00) Monrovia' => 'Africa/Monrovia',
    '(UTC+00:00) UTC' => 'UTC',
    '(UTC+01:00) Amsterdam' => 'Europe/Amsterdam',
    '(UTC+01:00) Belgrade' => 'Europe/Belgrade',
    '(UTC+01:00) Berlin' => 'Europe/Berlin',
    '(UTC+01:00) Bern' => 'Europe/Berlin',
    '(UTC+01:00) Bratislava' => 'Europe/Bratislava',
    '(UTC+01:00) Brussels' => 'Europe/Brussels',
    '(UTC+01:00) Budapest' => 'Europe/Budapest',
    '(UTC+01:00) Copenhagen' => 'Europe/Copenhagen',
    '(UTC+01:00) Ljubljana' => 'Europe/Ljubljana',
    '(UTC+01:00) Madrid' => 'Europe/Madrid',
    '(UTC+01:00) Paris' => 'Europe/Paris',
    '(UTC+01:00) Prague' => 'Europe/Prague',
    '(UTC+01:00) Rome' => 'Europe/Rome',
    '(UTC+01:00) Sarajevo' => 'Europe/Sarajevo',
    '(UTC+01:00) Skopje' => 'Europe/Skopje',
    '(UTC+01:00) Stockholm' => 'Europe/Stockholm',
    '(UTC+01:00) Vienna' => 'Europe/Vienna',
    '(UTC+01:00) Warsaw' => 'Europe/Warsaw',
    '(UTC+01:00) West Central Africa' => 'Africa/Lagos',
    '(UTC+01:00) Zagreb' => 'Europe/Zagreb',
    '(UTC+02:00) Athens' => 'Europe/Athens',
    '(UTC+02:00) Bucharest' => 'Europe/Bucharest',
    '(UTC+02:00) Cairo' => 'Africa/Cairo',
    '(UTC+02:00) Harare' => 'Africa/Harare',
    '(UTC+02:00) Helsinki' => 'Europe/Helsinki',
    '(UTC+02:00) Istanbul' => 'Europe/Istanbul',
    '(UTC+02:00) Jerusalem' => 'Asia/Jerusalem',
    '(UTC+02:00) Kyiv' => 'Europe/Helsinki',
    '(UTC+02:00) Pretoria' => 'Africa/Johannesburg',
    '(UTC+02:00) Riga' => 'Europe/Riga',
    '(UTC+02:00) Sofia' => 'Europe/Sofia',
    '(UTC+02:00) Tallinn' => 'Europe/Tallinn',
    '(UTC+02:00) Vilnius' => 'Europe/Vilnius',
    '(UTC+03:00) Baghdad' => 'Asia/Baghdad',
    '(UTC+03:00) Kuwait' => 'Asia/Kuwait',
    '(UTC+03:00) Minsk' => 'Europe/Minsk',
    '(UTC+03:00) Nairobi' => 'Africa/Nairobi',
    '(UTC+03:00) Riyadh' => 'Asia/Riyadh',
    '(UTC+03:00) Volgograd' => 'Europe/Volgograd',
    '(UTC+03:30) Tehran' => 'Asia/Tehran',
    '(UTC+04:00) Abu Dhabi' => 'Asia/Muscat',
    '(UTC+04:00) Baku' => 'Asia/Baku',
    '(UTC+04:00) Moscow' => 'Europe/Moscow',
    '(UTC+04:00) Muscat' => 'Asia/Muscat',
    '(UTC+04:00) St. Petersburg' => 'Europe/Moscow',
    '(UTC+04:00) Tbilisi' => 'Asia/Tbilisi',
    '(UTC+04:00) Yerevan' => 'Asia/Yerevan',
    '(UTC+04:30) Kabul' => 'Asia/Kabul',
    '(UTC+05:00) Islamabad' => 'Asia/Karachi',
    '(UTC+05:00) Karachi' => 'Asia/Karachi',
    '(UTC+05:00) Tashkent' => 'Asia/Tashkent',
    '(UTC+05:30) Chennai' => 'Asia/Calcutta',
    '(UTC+05:30) Kolkata' => 'Asia/Kolkata',
    '(UTC+05:30) Mumbai' => 'Asia/Calcutta',
    '(UTC+05:30) New Delhi' => 'Asia/Calcutta',
    '(UTC+05:30) Sri Jayawardenepura' => 'Asia/Calcutta',
    '(UTC+05:45) Kathmandu' => 'Asia/Katmandu',
    '(UTC+06:00) Almaty' => 'Asia/Almaty',
    '(UTC+06:00) Astana' => 'Asia/Dhaka',
    '(UTC+06:00) Dhaka' => 'Asia/Dhaka',
    '(UTC+06:00) Ekaterinburg' => 'Asia/Yekaterinburg',
    '(UTC+06:30) Rangoon' => 'Asia/Rangoon',
    '(UTC+07:00) Bangkok' => 'Asia/Bangkok',
    '(UTC+07:00) Hanoi' => 'Asia/Bangkok',
    '(UTC+07:00) Jakarta' => 'Asia/Jakarta',
    '(UTC+07:00) Novosibirsk' => 'Asia/Novosibirsk',
    '(UTC+08:00) Beijing' => 'Asia/Hong_Kong',
    '(UTC+08:00) Chongqing' => 'Asia/Chongqing',
    '(UTC+08:00) Hong Kong' => 'Asia/Hong_Kong',
    '(UTC+08:00) Krasnoyarsk' => 'Asia/Krasnoyarsk',
    '(UTC+08:00) Kuala Lumpur' => 'Asia/Kuala_Lumpur',
    '(UTC+08:00) Perth' => 'Australia/Perth',
    '(UTC+08:00) Singapore' => 'Asia/Singapore',
    '(UTC+08:00) Taipei' => 'Asia/Taipei',
    '(UTC+08:00) Ulaan Bataar' => 'Asia/Ulan_Bator',
    '(UTC+08:00) Urumqi' => 'Asia/Urumqi',
    '(UTC+09:00) Irkutsk' => 'Asia/Irkutsk',
    '(UTC+09:00) Osaka' => 'Asia/Tokyo',
    '(UTC+09:00) Sapporo' => 'Asia/Tokyo',
    '(UTC+09:00) Seoul' => 'Asia/Seoul',
    '(UTC+09:00) Tokyo' => 'Asia/Tokyo',
    '(UTC+09:30) Adelaide' => 'Australia/Adelaide',
    '(UTC+09:30) Darwin' => 'Australia/Darwin',
    '(UTC+10:00) Brisbane' => 'Australia/Brisbane',
    '(UTC+10:00) Canberra' => 'Australia/Canberra',
    '(UTC+10:00) Guam' => 'Pacific/Guam',
    '(UTC+10:00) Hobart' => 'Australia/Hobart',
    '(UTC+10:00) Melbourne' => 'Australia/Melbourne',
    '(UTC+10:00) Port Moresby' => 'Pacific/Port_Moresby',
    '(UTC+10:00) Sydney' => 'Australia/Sydney',
    '(UTC+10:00) Yakutsk' => 'Asia/Yakutsk',
    '(UTC+11:00) Vladivostok' => 'Asia/Vladivostok',
    '(UTC+12:00) Auckland' => 'Pacific/Auckland',
    '(UTC+12:00) Fiji' => 'Pacific/Fiji',
    '(UTC+12:00) International Date Line West' => 'Pacific/Kwajalein',
    '(UTC+12:00) Kamchatka' => 'Asia/Kamchatka',
    '(UTC+12:00) Magadan' => 'Asia/Magadan',
    '(UTC+12:00) Marshall Is.' => 'Pacific/Fiji',
    '(UTC+12:00) New Caledonia' => 'Asia/Magadan',
    '(UTC+12:00) Solomon Is.' => 'Asia/Magadan',
    '(UTC+12:00) Wellington' => 'Pacific/Auckland',
    '(UTC+13:00) Nuku\'alofa' => 'Pacific/Tongatapu'
);
      echo "<select class='form-control' name='wqmlrtimezone'>";
   foreach($arr as $key=>$data)
   {
	   if($zone==$data)
	   {
		  $selected="selected"; 
	   }
	   else
	   {
		   $selected="";
	   }
	   echo "<option value='".$data."' ".$selected.">".$key."</option>";
	   
   }
     echo "</select>";

}	
	
}




?>